; ###################################################################
; ###################################################################
; ##                                                               ##
; ##                      DDRAW include file                       ##
; ##                                                               ##
; ###################################################################
; ###################################################################
; ##                                                               ##
; ##  This file is a direct port of the Direct Draw C header file  ##
; ##  supplied with the DirectX 9 SDK.                             ##
; ##                                                               ##
; ###################################################################
; ###################################################################

; #############
; Missing types
; #############

IFNDEF REFGUID
REFGUID TYPEDEF PTR GUID
ENDIF

IFNDEF REFIID
REFIID TYPEDEF PTR IID
ENDIF

IFNDEF LPRECT
LPRECT TYPEDEF PTR RECT
ENDIF

IFNDEF LPSIZE
LPSIZE TYPEDEF PTR _SIZE
ENDIF

IFNDEF LPPALETTEENTRY
LPPALETTEENTRY TYPEDEF PTR PALETTEENTRY
ENDIF

IFNDEF LPRGNDATA
LPRGNDATA TYPEDEF PTR RGNDATA
ENDIF

IFNDEF LPDWORD
LPDWORD TYPEDEF PTR DWORD
ENDIF

IFNDEF LPLONG
LPLONG TYPEDEF PTR LONG
ENDIF

; #########
; STDMETHOD
; #########

IFNDEF STDMETHOD

STDMETHOD MACRO name:REQ, argl:VARARG
	LOCAL @tmp_a
	LOCAL @tmp_b

	@tmp_a	TYPEDEF PROTO argl
	@tmp_b	TYPEDEF PTR @tmp_a
	name		@tmp_b		?
ENDM

stdinvoke MACRO itype:REQ, func:REQ, this:REQ, arglist:VARARG
	LOCAL @vtblname

	IFNB <arglist>
		IF @InStr(1, <arglist>, <ecx>) NE 0
			.err <stdinvoke uses ecx: call will be corrupted>
		ENDIF
	ENDIF
	
	@vtblname TEXTEQU @CatStr(<itype>, <Vtbl>)

	mov ecx, this
	mov ecx, [ecx]

	IFB <arglist>
		invoke [@vtblname.func][ecx], this
	ELSE
		invoke [@vtblname.func][ecx], this, arglist
	ENDIF
ENDM

ENDIF

IFNDEF __DDRAW_INCLUDED__

__DDRAW_INCLUDED__						EQU 1

; ##########################################################################
;
; If you wish an application built against the newest version of DirectDraw
; to run against an older DirectDraw run time then define DIRECTDRAW_VERSION
; to be the earlies version of DirectDraw you wish to run against. For,
; example if you wish an application to run against a DX 3 runtime define
; DIRECTDRAW_VERSION to be 0x0300.
;
; ##########################################################################
 
IFNDEF  DIRECTDRAW_VERSION

DIRECTDRAW_VERSION  					EQU 0700h
ENDIF ; DIRECTDRAW_VERSION

; ###################
; Return value MACROs
; ###################

_FACDD									EQU 0876h

; ------------
; MAKE_HRESULT
; ------------

IFNDEF  MAKE_HRESULT

MAKE_HRESULT MACRO sev:REQ, fac:REQ, code:REQ
	EXITM ( ((sev SHL 31) AND 080000000h) OR ((fac SHL 16) AND 07FFF0000h) OR (code AND 00000FFFFh) )
ENDM

ENDIF ; MAKE_HRESULT

; --------------
; MAKE_DDHRESULT
; --------------

IFNDEF  MAKE_DDHRESULT

MAKE_DDHRESULT MACRO code:REQ
	EXITM (MAKE_HRESULT(1, _FACDD, code))
ENDM

ENDIF ; MAKE_DDHRESULT

; ----------
; MAKEFOURCC
; ----------

MAKEFOURCC MACRO ch0:REQ, ch1:REQ, ch2:REQ, ch3:REQ
	EXITM ((ch0 AND 0FFh) OR ((ch1 SHL 8) AND 0FF00h) OR ((ch1 SHL 16) AND 0FF0000h) OR ((ch1 SHL 24) AND 0FF000000h)) 
ENDM

; ####################################################
; FOURCC codes for DX compressed-texture pixel formats
; ####################################################

FOURCC_DXT1  							EQU 44585431h
FOURCC_DXT2  							EQU 44585432h
FOURCC_DXT3  							EQU 44585433h
FOURCC_DXT4  							EQU 44585434h
FOURCC_DXT5  							EQU 44585435h

; ################################
; GUIDS used by DirectDraw objects
; ################################

EXTERNDEF	C CLSID_DirectDraw:GUID
EXTERNDEF	C CLSID_DirectDraw7:GUID

EXTERNDEF	C CLSID_DirectDrawClipper:GUID

EXTERNDEF	C IID_IDirectDraw:GUID
EXTERNDEF	C IID_IDirectDraw2:GUID
EXTERNDEF	C IID_IDirectDraw4:GUID
EXTERNDEF	C IID_IDirectDraw7:GUID

EXTERNDEF	C IID_IDirectDrawSurface:GUID
EXTERNDEF	C IID_IDirectDrawSurface2:GUID
EXTERNDEF	C IID_IDirectDrawSurface3:GUID
EXTERNDEF	C IID_IDirectDrawSurface4:GUID
EXTERNDEF	C IID_IDirectDrawSurface7:GUID

EXTERNDEF	C IID_IDirectDrawPalette:GUID
EXTERNDEF	C IID_IDirectDrawClipper:GUID
EXTERNDEF	C IID_IDirectDrawColorControl:GUID
EXTERNDEF	C IID_IDirectDrawGammaControl:GUID

; =========================
; Here's the C for that btw
; =========================

; #if defined( _WIN32 ) && !defined( _NO_COM )
;
; DEFINE_GUID( CLSID_DirectDraw,                  0xD7B70EE0,0x4340,0x11CF,0xB0,0x63,0x00,0x20,0xAF,0xC2,0xCD,0x35 );
; DEFINE_GUID( CLSID_DirectDraw7,                 0x3c305196,0x50db,0x11d3,0x9c,0xfe,0x00,0xc0,0x4f,0xd9,0x30,0xc5 );
; DEFINE_GUID( CLSID_DirectDrawClipper,           0x593817A0,0x7DB3,0x11CF,0xA2,0xDE,0x00,0xAA,0x00,0xb9,0x33,0x56 );
; DEFINE_GUID( IID_IDirectDraw,                   0x6C14DB80,0xA733,0x11CE,0xA5,0x21,0x00,0x20,0xAF,0x0B,0xE5,0x60 );
; DEFINE_GUID( IID_IDirectDraw2,                  0xB3A6F3E0,0x2B43,0x11CF,0xA2,0xDE,0x00,0xAA,0x00,0xB9,0x33,0x56 );
; DEFINE_GUID( IID_IDirectDraw4,                  0x9c59509a,0x39bd,0x11d1,0x8c,0x4a,0x00,0xc0,0x4f,0xd9,0x30,0xc5 );
; DEFINE_GUID( IID_IDirectDraw7,                  0x15e65ec0,0x3b9c,0x11d2,0xb9,0x2f,0x00,0x60,0x97,0x97,0xea,0x5b );
; DEFINE_GUID( IID_IDirectDrawSurface,            0x6C14DB81,0xA733,0x11CE,0xA5,0x21,0x00,0x20,0xAF,0x0B,0xE5,0x60 );
; DEFINE_GUID( IID_IDirectDrawSurface2,           0x57805885,0x6eec,0x11cf,0x94,0x41,0xa8,0x23,0x03,0xc1,0x0e,0x27 );
; DEFINE_GUID( IID_IDirectDrawSurface3,           0xDA044E00,0x69B2,0x11D0,0xA1,0xD5,0x00,0xAA,0x00,0xB8,0xDF,0xBB );
; DEFINE_GUID( IID_IDirectDrawSurface4,           0x0B2B8630,0xAD35,0x11D0,0x8E,0xA6,0x00,0x60,0x97,0x97,0xEA,0x5B );
; DEFINE_GUID( IID_IDirectDrawSurface7,           0x06675a80,0x3b9b,0x11d2,0xb9,0x2f,0x00,0x60,0x97,0x97,0xea,0x5b );
;
; DEFINE_GUID( IID_IDirectDrawPalette,            0x6C14DB84,0xA733,0x11CE,0xA5,0x21,0x00,0x20,0xAF,0x0B,0xE5,0x60 );
; DEFINE_GUID( IID_IDirectDrawClipper,            0x6C14DB85,0xA733,0x11CE,0xA5,0x21,0x00,0x20,0xAF,0x0B,0xE5,0x60 );
; DEFINE_GUID( IID_IDirectDrawColorControl,       0x4B9F0EE0,0x0D7E,0x11D0,0x9B,0x06,0x00,0xA0,0xC9,0x03,0xA3,0xB8 );
; DEFINE_GUID( IID_IDirectDrawGammaControl,       0x69C11C3E,0xB46B,0x11D1,0xAD,0x7A,0x00,0xC0,0x4F,0xC2,0x9B,0x4E );
;
; #endif 

; #############################################
;
; DirectDraw Structures
;
; Various structures used to invoke DirectDraw.
;
; #############################################

LPDIRECTDRAW				TYPEDEF		PTR IDirectDraw
LPDIRECTDRAW2				TYPEDEF		PTR IDirectDraw2
LPDIRECTDRAW4				TYPEDEF		PTR IDirectDraw4
LPDIRECTDRAW7				TYPEDEF		PTR IDirectDraw7

LPDIRECTDRAWSURFACE			TYPEDEF		PTR IDirectDrawSurface
LPDIRECTDRAWSURFACE2		TYPEDEF		PTR IDirectDrawSurface2
LPDIRECTDRAWSURFACE3		TYPEDEF		PTR IDirectDrawSurface3
LPDIRECTDRAWSURFACE4		TYPEDEF		PTR IDirectDrawSurface4
LPDIRECTDRAWSURFACE7		TYPEDEF		PTR IDirectDrawSurface7

LPDIRECTDRAWPALETTE			TYPEDEF		PTR IDirectDrawPalette
LPDIRECTDRAWCLIPPER			TYPEDEF		PTR IDirectDrawClipper
LPDIRECTDRAWCOLORCONTROL	TYPEDEF		PTR IDirectDrawColorControl
LPDIRECTDRAWGAMMACONTROL	TYPEDEF		PTR IDirectDrawGammaControl

LPDDFXROP					TYPEDEF		PTR DDFXROP
LPDDSURFACEDESC				TYPEDEF		PTR DDSURFACEDESC
LPDDSURFACEDESC2			TYPEDEF		PTR DDSURFACEDESC2
LPDDCOLORCONTROL			TYPEDEF		PTR DDCOLORCONTROL

; ####
; APIs
; ####

; Direct Draw Enumeration

LPDDENUMCALLBACKA			TYPEDEF DWORD
LPDDENUMCALLBACKW			TYPEDEF DWORD

DirectDrawEnumerateA		PROTO :LPDDENUMCALLBACKA, :LPVOID
DirectDrawEnumerateW		PROTO :LPDDENUMCALLBACKW, :LPVOID

; Direct Draw Enumeration Extended

LPDDENUMCALLBACKEXA			TYPEDEF DWORD
LPDDENUMCALLBACKEXW			TYPEDEF DWORD

DirectDrawEnumerateExA		PROTO :LPDDENUMCALLBACKEXA, :LPVOID, :DWORD
DirectDrawEnumerateExW		PROTO :LPDDENUMCALLBACKEXW, :LPVOID, :DWORD

LPDIRECTDRAWENUMERATEEXA	TYPEDEF DWORD
LPDIRECTDRAWENUMERATEEXW	TYPEDEF DWORD

; Unicodify

LPDDENUMCALLBACK			TYPEDEF DWORD
LPDDENUMCALLBACKEX			TYPEDEF DWORD
LPDIRECTDRAWENUMERATEEX		TYPEDEF DWORD

IFDEF UNICODE
	DirectDrawEnumerate					EQU <DirectDrawEnumerateW>
	DirectDrawEnumerateEx				EQU <DirectDrawEnumerateExW>
ELSE
	DirectDrawEnumerate					EQU <DirectDrawEnumerateA>
	DirectDrawEnumerateEx				EQU <DirectDrawEnumerateExA>
ENDIF

; Create* APIs

DirectDrawCreate			PROTO :PTR GUID, :PTR LPDIRECTDRAW, :PTR IUnknown
DirectDrawCreateEx			PROTO :PTR GUID, :LPVOID, :REFIID, :PTR IUnknown
DirectDrawCreateClipper		PROTO :DWORD, :PTR LPDIRECTDRAWCLIPPER, :PTR IUnknown

; #####################################################################################
;
; Flags for DirectDrawEnumerateEx
; DirectDrawEnumerateEx supercedes DirectDrawEnumerate. You must use GetProcAddress to
; obtain a function pointer (of type LPDIRECTDRAWENUMERATEEX) to DirectDrawEnumerateEx.
; By default, only the primary display device is enumerated.
; DirectDrawEnumerate is equivalent to DirectDrawEnumerate(,,DDENUM_NONDISPLAYDEVICES)
;
; #####################################################################################

; This flag causes enumeration of any GDI display devices which are part of
; the Windows Desktop

DDENUM_ATTACHEDSECONDARYDEVICES		EQU 00000001h

; This flag causes enumeration of any GDI display devices which are not
; part of the Windows Desktop

DDENUM_DETACHEDSECONDARYDEVICES		EQU 00000002h

; This flag causes enumeration of non-display devices

DDENUM_NONDISPLAYDEVICES			EQU 00000004h

REGSTR_KEY_DDHW_DESCRIPTION			EQU <Description>
REGSTR_KEY_DDHW_DRIVERNAME			EQU <DriverName>
REGSTR_PATH_DDHW					EQU <Hardware\DirectDrawDrivers>

DDCREATE_HARDWAREONLY				EQU 00000001h
DCREATE_EMULATIONONLY				EQU 00000002h

LPDDENUMMODESCALLBACK				TYPEDEF PTR
LPDDENUMMODESCALLBACK2				TYPEDEF PTR
LPDDENUMSURFACESCALLBACK			TYPEDEF PTR
LPDDENUMSURFACESCALLBACK2			TYPEDEF PTR
LPDDENUMSURFACESCALLBACK7			TYPEDEF PTR

; ############################################################################
;
; DDARGB
;
; Generic pixel format with 8-bit RGB and alpha components
;
; ############################################################################

DDARGB STRUCT 
    blue	BYTE ?
    green	BYTE ?
    red		BYTE ?
    alpha	BYTE ?
DDARGB ENDS 

LPDDARGB							TYPEDEF PTR DDARGB

; ############################################################################
;
; DDRGBA
;
; This version of the structure remains for backwards source compatibility.
; The DDARGB structure is the one that should be used for all DirectDraw APIs.
;
; ############################################################################

DDRGBA STRUCT 
    red		BYTE ?
    green	BYTE ?
    blue	BYTE ?
    alpha	BYTE ?
DDRGBA ENDS 

LPDDRGBA							TYPEDEF PTR DDRGBA

; ##########
; DDCOLORKEY
; ##########

DDCOLORKEY STRUCT
    dwColorSpaceLowValue 		DWORD ?		; low boundary of color space that is to
    										; be treated as Color Key, inclusive
    dwColorSpaceHighValue		DWORD ?		; high boundary of color space that is
    										; to be treated as Color Key, inclusive
DDCOLORKEY ENDS

LPDDCOLORKEY 					TYPEDEF PTR DDCOLORKEY;

; ########################################################################
;
; DDBLTFX
;
; Used to pass override information to the DIRECTDRAWSURFACE callback Blt.
;
; ########################################################################

DDBLTFX STRUCT
	dwSize						DWORD	?				; size of structure
	dwDDFX						DWORD	?				; FX operations
	dwROP						DWORD	?				; Win32 raster operations
	dwDDROP						DWORD	?				; Raster operations new for DirectDraw
	dwRotationAngle				DWORD	?				; Rotation angle for blt
	dwZBufferOpCode				DWORD	?				; ZBuffer compares
	dwZBufferLow				DWORD	?				; Low limit of Z buffer
	dwZBufferHigh				DWORD	?				; High limit of Z buffer
	dwZBufferBaseDest			DWORD	?				; Destination base value
	dwZDestConstBitDepth		DWORD	?				; Bit depth used to specify Z constant for destination
	UNION
		dwZDestConst			DWORD	?				; Constant to use as Z buffer for dest
		lpDDSZBufferDest		LPDIRECTDRAWSURFACE	?	; Surface to use as Z buffer for dest
	ENDS
	dwZSrcConstBitDepth			DWORD	?				; Bit depth used to specify Z constant for source
	UNION
		dwZSrcConst				DWORD	?				; Constant to use as Z buffer for src
		lpDDSZBufferSrc			LPDIRECTDRAWSURFACE	?	; Surface to use as Z buffer for src
	ENDS
	dwAlphaEdgeBlendBitDepth	DWORD	?				; Bit depth used to specify constant for alpha edge blend
	dwAlphaEdgeBlend			DWORD	?				; Alpha for edge blending
	dwReserved					DWORD	?				;
	dwAlphaDestConstBitDepth	DWORD	?				; Bit depth used to specify alpha constant for destination
	UNION
		dwAlphaDestConst		DWORD	?				; Constant to use as Alpha Channel
		lpDDSAlphaDest			LPDIRECTDRAWSURFACE	?	; Surface to use as Alpha Channel
	ENDS
	dwAlphaSrcConstBitDepth		DWORD	?				; Bit depth used to specify alpha constant for source
	UNION
		dwAlphaSrcConst			DWORD	?				; Constant to use as Alpha Channel
		lpDDSAlphaSrc			LPDIRECTDRAWSURFACE	?	; Surface to use as Alpha Channel
	ENDS
	UNION
		dwFillColor				DWORD	?				; color in RGB or Palettized
		dwFillDepth				DWORD	?				; depth value for z-buffer
		dwFillPixel				DWORD	?				; pixel value for RGBA or RGBZ
		lpDDSPattern			LPDIRECTDRAWSURFACE	?	; Surface to use as pattern
	ENDS
	ddckDestColorkey			DDCOLORKEY	<>			; DestColorkey override
	ddckSrcColorkey				DDCOLORKEY	<>			; SrcColorkey override
DDBLTFX		ENDS

LPDDBLTFX 						TYPEDEF PTR DDBLTFX

; #######
; DDSCAPS
; #######

DDSCAPS STRUCT
	dwCaps	DWORD ?										; capabilities of surface wanted
DDSCAPS ENDS

LPDDSCAPS 						TYPEDEF PTR DDSCAPS

; ########
; DDOSCAPS
; ########

DDOSCAPS STRUCT
	dwCaps	DWORD ?										; capabilities of surface wanted
DDOSCAPS ENDS

LPDDOSCAPS 						TYPEDEF PTR DDOSCAPS

; ################################################
; This structure is used internally by DirectDraw.
; ################################################

DDSCAPSEX STRUCT
	dwCaps2				DWORD ?
	dwCaps3				DWORD ?
	UNION
		dwCaps4			DWORD ?
		dwVolumeDepth	DWORD ?
	ENDS
DDSCAPSEX ENDS

LPDDSCAPSEX						TYPEDEF PTR DDSCAPSEX

; ########
; DDSCAPS2
; ########

DDSCAPS2 STRUCT
	dwCaps	DWORD ?
	dwCaps2	DWORD ?
	dwCaps3	DWORD ?
	UNION
		dwCaps4			DWORD ?
		dwVolumeDepth	DWORD ?
	ENDS
DDSCAPS2 ENDS

LPDDSCAPS2 						TYPEDEF PTR DDSCAPS2

; ######
; DDCAPS
; ######

DD_ROP_SPACE							EQU (256/32) ; space required to store ROP array
; NOTE: Our choosen structure number scheme is to append a single digit to
; the end of the structure giving the version that structure is associated
; with.

; ############################################################################################################
;
; This structure represents the DDCAPS structure released in DirectDraw 1.0.  It is used internally
; by DirectDraw to interpret caps passed into ddraw by drivers written prior to the release of DirectDraw 2.0.
; New applications should use the DDCAPS structure defined below.
;
; ############################################################################################################

DDCAPS_DX1 STRUCT
	dwSize							DWORD	?						; size of the DDDRIVERCAPS structure
	dwCaps							DWORD	?						; driver specific capabilities
	dwCaps2							DWORD	?						; more driver specific capabilites
	dwCKeyCaps						DWORD	?						; color key capabilities of the surface
	dwFXCaps						DWORD	?						; driver specific stretching and effects capabilites
	dwFXAlphaCaps					DWORD	?						; alpha driver specific capabilities
	dwPalCaps						DWORD	?						; palette capabilities
	dwSVCaps						DWORD	?						; stereo vision capabilities
	dwAlphaBltConstBitDepths		DWORD	?						; DDBD_2,4,8
	dwAlphaBltPixelBitDepths		DWORD	?						; DDBD_1,2,4,8
	dwAlphaBltSurfaceBitDepths		DWORD	?						; DDBD_1,2,4,8
	dwAlphaOverlayConstBitDepths	DWORD	?						; DDBD_2,4,8
	dwAlphaOverlayPixelBitDepths	DWORD	?						; DDBD_1,2,4,8
	dwAlphaOverlaySurfaceBitDepths	DWORD	?						; DDBD_1,2,4,8
	dwZBufferBitDepths				DWORD	?						; DDBD_8,16,24,32
	dwVidMemTotal					DWORD	?						; total amount of video memory
	dwVidMemFree					DWORD	?						; amount of free video memory
	dwMaxVisibleOverlays			DWORD	?						; maximum number of visible overlays
	dwCurrVisibleOverlays			DWORD	?						; current number of visible overlays
	dwNumFourCCCodes				DWORD	?						; number of four cc codes
	dwAlignBoundarySrc				DWORD	?						; source rectangle alignment
	dwAlignSizeSrc					DWORD	?						; source rectangle byte size
	dwAlignBoundaryDest				DWORD	?						; dest rectangle alignment
	dwAlignSizeDest					DWORD	?						; dest rectangle byte size
	dwAlignStrideAlign				DWORD	?						; stride alignment
	dwRops							DWORD	DD_ROP_SPACE dup (?)	; ROPS supported
	ddsCaps							DDSCAPS	<>						; DDSCAPS structure has all the general capabilities
	dwMinOverlayStretch				DWORD	?						; minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
	dwMaxOverlayStretch				DWORD	?						; maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
	dwMinLiveVideoStretch			DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMaxLiveVideoStretch			DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMinHwCodecStretch				DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMaxHwCodecStretch				DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwReserved1						DWORD	?						; reserved
	dwReserved2						DWORD	?						; reserved
	dwReserved3						DWORD	?						; reserved
DDCAPS_DX1 ENDS

LPDDCAPS_DX1 TYPEDEF PTR DDCAPS_DX1

; ################################################################################
;
; This structure is the DDCAPS structure as it was in version 2 and 3 of Direct X.
; It is present for back compatability.
;
; ################################################################################

DDCAPS_DX3 STRUCT
	dwSize							DWORD	?						; size of the DDDRIVERCAPS structure
	dwCaps							DWORD	?						; driver specific capabilities
	dwCaps2							DWORD	?						; more driver specific capabilites
	dwCKeyCaps						DWORD	?						; color key capabilities of the surface
	dwFXCaps						DWORD	?						; driver specific stretching and effects capabilites
	dwFXAlphaCaps					DWORD	?						; alpha driver specific capabilities
	dwPalCaps						DWORD	?						; palette capabilities
	dwSVCaps						DWORD	?						; stereo vision capabilities
	dwAlphaBltConstBitDepths		DWORD	?						; DDBD_2,4,8
	dwAlphaBltPixelBitDepths		DWORD	?						; DDBD_1,2,4,8
	dwAlphaBltSurfaceBitDepths		DWORD	?						; DDBD_1,2,4,8
	dwAlphaOverlayConstBitDepths	DWORD	?						; DDBD_2,4,8
	dwAlphaOverlayPixelBitDepths	DWORD	?						; DDBD_1,2,4,8
	dwAlphaOverlaySurfaceBitDepths	DWORD	?						; DDBD_1,2,4,8
	dwZBufferBitDepths				DWORD	?						; DDBD_8,16,24,32
	dwVidMemTotal					DWORD	?						; total amount of video memory
	dwVidMemFree					DWORD	?						; amount of free video memory
	dwMaxVisibleOverlays			DWORD	?						; maximum number of visible overlays
	dwCurrVisibleOverlays			DWORD	?						; current number of visible overlays
	dwNumFourCCCodes				DWORD	?						; number of four cc codes
	dwAlignBoundarySrc				DWORD	?						; source rectangle alignment
	dwAlignSizeSrc					DWORD	?						; source rectangle byte size
	dwAlignBoundaryDest				DWORD	?						; dest rectangle alignment
	dwAlignSizeDest					DWORD	?						; dest rectangle byte size
	dwAlignStrideAlign				DWORD	?						; stride alignment
	dwRops							DWORD	DD_ROP_SPACE dup (?)	; ROPS supported
	ddsCaps							DDSCAPS	<>						; DDSCAPS structure has all the general capabilities
	dwMinOverlayStretch				DWORD	?						; minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
	dwMaxOverlayStretch				DWORD	?						; maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
	dwMinLiveVideoStretch			DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMaxLiveVideoStretch			DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMinHwCodecStretch				DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMaxHwCodecStretch				DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwReserved1						DWORD	?						; reserved
	dwReserved2						DWORD	?						; reserved
	dwReserved3						DWORD	?						; reserved
	dwSVBCaps						DWORD	?						; driver specific capabilities for System->Vmem blts
	dwSVBCKeyCaps					DWORD	?						; driver color key capabilities for System->Vmem blts
	dwSVBFXCaps						DWORD	?						; driver FX capabilities for System->Vmem blts
	dwSVBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for System->Vmem blts
	dwVSBCaps						DWORD	?						; driver specific capabilities for Vmem->System blts
	dwVSBCKeyCaps					DWORD	?						; driver color key capabilities for Vmem->System blts
	dwVSBFXCaps						DWORD	?						; driver FX capabilities for Vmem->System blts
	dwVSBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for Vmem->System blts
	dwSSBCaps						DWORD	?						; driver specific capabilities for System->System blts
	dwSSBCKeyCaps					DWORD	?						; driver color key capabilities for System->System blts
	dwSSBFXCaps						DWORD	?						; driver FX capabilities for System->System blts
	dwSSBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for System->System blts
	dwReserved4						DWORD	?						; reserved
	dwReserved5						DWORD	?						; reserved
	dwReserved6						DWORD	?						; reserved
DDCAPS_DX3 ENDS

; ##########################################################################
;
; This structure is the DDCAPS structure as it was in version 5 of Direct X.
; It is present for back compatability.
;
; ##########################################################################

DDCAPS_DX5 STRUCT
	dwSize							DWORD	?						; size of the DDDRIVERCAPS structure
	dwCaps							DWORD	?						; driver specific capabilities
	dwCaps2							DWORD	?						; more driver specific capabilites
	dwCKeyCaps						DWORD	?						; color key capabilities of the surface
	dwFXCaps						DWORD	?						; driver specific stretching and effects capabilites
	dwFXAlphaCaps					DWORD	?						; alpha driver specific capabilities
	dwPalCaps						DWORD	?						; palette capabilities
	dwSVCaps						DWORD	?						; stereo vision capabilities
	dwAlphaBltConstBitDepths		DWORD	?						; DDBD_2,4,8
	dwAlphaBltPixelBitDepths		DWORD	?						; DDBD_1,2,4,8
	dwAlphaBltSurfaceBitDepths		DWORD	?						; DDBD_1,2,4,8
	dwAlphaOverlayConstBitDepths	DWORD	?						; DDBD_2,4,8
	dwAlphaOverlayPixelBitDepths	DWORD	?						; DDBD_1,2,4,8
	dwAlphaOverlaySurfaceBitDepths	DWORD	?						; DDBD_1,2,4,8
	dwZBufferBitDepths				DWORD	?						; DDBD_8,16,24,32
	dwVidMemTotal					DWORD	?						; total amount of video memory
	dwVidMemFree					DWORD	?						; amount of free video memory
	dwMaxVisibleOverlays			DWORD	?						; maximum number of visible overlays
	dwCurrVisibleOverlays			DWORD	?						; current number of visible overlays
	dwNumFourCCCodes				DWORD	?						; number of four cc codes
	dwAlignBoundarySrc				DWORD	?						; source rectangle alignment
	dwAlignSizeSrc					DWORD	?						; source rectangle byte size
	dwAlignBoundaryDest				DWORD	?						; dest rectangle alignment
	dwAlignSizeDest					DWORD	?						; dest rectangle byte size
	dwAlignStrideAlign				DWORD	?						; stride alignment
	dwRops							DWORD	DD_ROP_SPACE dup (?)	; ROPS supported
	ddsCaps							DDSCAPS	<>						; DDSCAPS structure has all the general capabilities
	dwMinOverlayStretch				DWORD	?						; minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
	dwMaxOverlayStretch				DWORD	?						; maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
	dwMinLiveVideoStretch			DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMaxLiveVideoStretch			DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMinHwCodecStretch				DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMaxHwCodecStretch				DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwReserved1						DWORD	?						; reserved
	dwReserved2						DWORD	?						; reserved
	dwReserved3						DWORD	?						; reserved
	dwSVBCaps						DWORD	?						; driver specific capabilities for System->Vmem blts
	dwSVBCKeyCaps					DWORD	?						; driver color key capabilities for System->Vmem blts
	dwSVBFXCaps						DWORD	?						; driver FX capabilities for System->Vmem blts
	dwSVBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for System->Vmem blts
	dwVSBCaps						DWORD	?						; driver specific capabilities for Vmem->System blts
	dwVSBCKeyCaps					DWORD	?						; driver color key capabilities for Vmem->System blts
	dwVSBFXCaps						DWORD	?						; driver FX capabilities for Vmem->System blts
	dwVSBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for Vmem->System blts
	dwSSBCaps						DWORD	?						; driver specific capabilities for System->System blts
	dwSSBCKeyCaps					DWORD	?						; driver color key capabilities for System->System blts
	dwSSBFXCaps						DWORD	?						; driver FX capabilities for System->System blts
	dwSSBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for System->System blts
	; Members added for DX5:
	dwMaxVideoPorts					DWORD	?						; maximum number of usable video ports
	dwCurrVideoPorts				DWORD	?						; current number of video ports used
	dwSVBCaps2						DWORD	?						; more driver specific capabilities for System->Vmem blts
	dwNLVBCaps						DWORD	?						; driver specific capabilities for non-local->local vidmem blts
	dwNLVBCaps2						DWORD	?						; more driver specific capabilities non-local->local vidmem blts
	dwNLVBCKeyCaps					DWORD	?						; driver color key capabilities for non-local->local vidmem blts
	dwNLVBFXCaps					DWORD	?						; driver FX capabilities for non-local->local blts
	dwNLVBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for non-local->local blts
DDCAPS_DX5 ENDS

LPDDCAPS_DX5 TYPEDEF PTR DDCAPS_DX5

DDCAPS_DX6 STRUCT
	dwSize							DWORD	?						; size of the DDDRIVERCAPS structure
	dwCaps							DWORD	?						; driver specific capabilities
	dwCaps2							DWORD	?						; more driver specific capabilites
	dwCKeyCaps						DWORD	?						; color key capabilities of the surface
	dwFXCaps						DWORD	?						; driver specific stretching and effects capabilites
	dwFXAlphaCaps					DWORD	?						; alpha driver specific capabilities
	dwPalCaps						DWORD	?						; palette capabilities
	dwSVCaps						DWORD	?						; stereo vision capabilities
	dwAlphaBltConstBitDepths		DWORD	?						; DDBD_2,4,8
	dwAlphaBltPixelBitDepths		DWORD	?						; DDBD_1,2,4,8
	dwAlphaBltSurfaceBitDepths		DWORD	?						; DDBD_1,2,4,8
	dwAlphaOverlayConstBitDepths	DWORD	?						; DDBD_2,4,8
	dwAlphaOverlayPixelBitDepths	DWORD	?						; DDBD_1,2,4,8
	dwAlphaOverlaySurfaceBitDepths	DWORD	?						; DDBD_1,2,4,8
	dwZBufferBitDepths				DWORD	?						; DDBD_8,16,24,32
	dwVidMemTotal					DWORD	?						; total amount of video memory
	dwVidMemFree					DWORD	?						; amount of free video memory
	dwMaxVisibleOverlays			DWORD	?						; maximum number of visible overlays
	dwCurrVisibleOverlays			DWORD	?						; current number of visible overlays
	dwNumFourCCCodes				DWORD	?						; number of four cc codes
	dwAlignBoundarySrc				DWORD	?						; source rectangle alignment
	dwAlignSizeSrc					DWORD	?						; source rectangle byte size
	dwAlignBoundaryDest				DWORD	?						; dest rectangle alignment
	dwAlignSizeDest					DWORD	?						; dest rectangle byte size
	dwAlignStrideAlign				DWORD	?						; stride alignment
	dwRops							DWORD	DD_ROP_SPACE dup (?)	; ROPS supported
	ddsOldCaps						DDSCAPS	<>						; DDSCAPS structure has all the general capabilities
	dwMinOverlayStretch				DWORD	?						; minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
	dwMaxOverlayStretch				DWORD	?						; maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
	dwMinLiveVideoStretch			DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMaxLiveVideoStretch			DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMinHwCodecStretch				DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMaxHwCodecStretch				DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwReserved1						DWORD	?						; reserved
	dwReserved2						DWORD	?						; reserved
	dwReserved3						DWORD	?						; reserved
	dwSVBCaps						DWORD	?						; driver specific capabilities for System->Vmem blts
	dwSVBCKeyCaps					DWORD	?						; driver color key capabilities for System->Vmem blts
	dwSVBFXCaps						DWORD	?						; driver FX capabilities for System->Vmem blts
	dwSVBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for System->Vmem blts
	dwVSBCaps						DWORD	?						; driver specific capabilities for Vmem->System blts
	dwVSBCKeyCaps					DWORD	?						; driver color key capabilities for Vmem->System blts
	dwVSBFXCaps						DWORD	?						; driver FX capabilities for Vmem->System blts
	dwVSBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for Vmem->System blts
	dwSSBCaps						DWORD	?						; driver specific capabilities for System->System blts
	dwSSBCKeyCaps					DWORD	?						; driver color key capabilities for System->System blts
	dwSSBFXCaps						DWORD	?						; driver FX capabilities for System->System blts
	dwSSBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for System->System blts
	; Members added for DX5:
	dwMaxVideoPorts					DWORD	?						; maximum number of usable video ports
	dwCurrVideoPorts				DWORD	?						; current number of video ports used
	dwSVBCaps2						DWORD	?						; more driver specific capabilities for System->Vmem blts
	dwNLVBCaps						DWORD	?						; driver specific capabilities for non-local->local vidmem blts
	dwNLVBCaps2						DWORD	?						; more driver specific capabilities non-local->local vidmem blts
	dwNLVBCKeyCaps					DWORD	?						; driver color key capabilities for non-local->local vidmem blts
	dwNLVBFXCaps					DWORD	?						; driver FX capabilities for non-local->local blts
	dwNLVBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for non-local->local blts
	; Members added for DX6 release:
	ddsCaps							DDSCAPS2	<>					; Surface Caps
DDCAPS_DX6 ENDS

LPDDCAPS_DX6 TYPEDEF PTR DDCAPS_DX6

DDCAPS_DX7 STRUCT
	dwSize							DWORD	?						; size of the DDDRIVERCAPS structure
	dwCaps							DWORD	?						; driver specific capabilities
	dwCaps2							DWORD	?						; more driver specific capabilites
	dwCKeyCaps						DWORD	?						; color key capabilities of the surface
	dwFXCaps						DWORD	?						; driver specific stretching and effects capabilites
	dwFXAlphaCaps					DWORD	?						; alpha driver specific capabilities
	dwPalCaps						DWORD	?						; palette capabilities
	dwSVCaps						DWORD	?						; stereo vision capabilities
	dwAlphaBltConstBitDepths		DWORD	?						; DDBD_2,4,8
	dwAlphaBltPixelBitDepths		DWORD	?						; DDBD_1,2,4,8
	dwAlphaBltSurfaceBitDepths		DWORD	?						; DDBD_1,2,4,8
	dwAlphaOverlayConstBitDepths	DWORD	?						; DDBD_2,4,8
	dwAlphaOverlayPixelBitDepths	DWORD	?						; DDBD_1,2,4,8
	dwAlphaOverlaySurfaceBitDepths	DWORD	?						; DDBD_1,2,4,8
	dwZBufferBitDepths				DWORD	?						; DDBD_8,16,24,32
	dwVidMemTotal					DWORD	?						; total amount of video memory
	dwVidMemFree					DWORD	?						; amount of free video memory
	dwMaxVisibleOverlays			DWORD	?						; maximum number of visible overlays
	dwCurrVisibleOverlays			DWORD	?						; current number of visible overlays
	dwNumFourCCCodes				DWORD	?						; number of four cc codes
	dwAlignBoundarySrc				DWORD	?						; source rectangle alignment
	dwAlignSizeSrc					DWORD	?						; source rectangle byte size
	dwAlignBoundaryDest				DWORD	?						; dest rectangle alignment
	dwAlignSizeDest					DWORD	?						; dest rectangle byte size
	dwAlignStrideAlign				DWORD	?						; stride alignment
	dwRops							DWORD	DD_ROP_SPACE dup (?)	; ROPS supported
	ddsOldCaps						DDSCAPS	<>						; DDSCAPS structure has all the general capabilities
	dwMinOverlayStretch				DWORD	?						; minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
	dwMaxOverlayStretch				DWORD	?						; maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
	dwMinLiveVideoStretch			DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMaxLiveVideoStretch			DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMinHwCodecStretch				DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwMaxHwCodecStretch				DWORD	?						; OBSOLETE! This field remains for compatability reasons only
	dwReserved1						DWORD	?						; reserved
	dwReserved2						DWORD	?						; reserved
	dwReserved3						DWORD	?						; reserved
	dwSVBCaps						DWORD	?						; driver specific capabilities for System->Vmem blts
	dwSVBCKeyCaps					DWORD	?						; driver color key capabilities for System->Vmem blts
	dwSVBFXCaps						DWORD	?						; driver FX capabilities for System->Vmem blts
	dwSVBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for System->Vmem blts
	dwVSBCaps						DWORD	?						; driver specific capabilities for Vmem->System blts
	dwVSBCKeyCaps					DWORD	?						; driver color key capabilities for Vmem->System blts
	dwVSBFXCaps						DWORD	?						; driver FX capabilities for Vmem->System blts
	dwVSBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for Vmem->System blts
	dwSSBCaps						DWORD	?						; driver specific capabilities for System->System blts
	dwSSBCKeyCaps					DWORD	?						; driver color key capabilities for System->System blts
	dwSSBFXCaps						DWORD	?						; driver FX capabilities for System->System blts
	dwSSBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for System->System blts
	; Members added for DX5:
	dwMaxVideoPorts					DWORD	?						; maximum number of usable video ports
	dwCurrVideoPorts				DWORD	?						; current number of video ports used
	dwSVBCaps2						DWORD	?						; more driver specific capabilities for System->Vmem blts
	dwNLVBCaps						DWORD	?						; driver specific capabilities for non-local->local vidmem blts
	dwNLVBCaps2						DWORD	?						; more driver specific capabilities non-local->local vidmem blts
	dwNLVBCKeyCaps					DWORD	?						; driver color key capabilities for non-local->local vidmem blts
	dwNLVBFXCaps					DWORD	?						; driver FX capabilities for non-local->local blts
	dwNLVBRops						DWORD	DD_ROP_SPACE dup (?)	; ROPS supported for non-local->local blts
	; Members added for DX6 release:
	ddsCaps							DDSCAPS2	<>					; Surface Caps
DDCAPS_DX7 ENDS

LPDDCAPS_DX7 TYPEDEF PTR DDCAPS_DX7

IF DIRECTDRAW_VERSION LE 0300h
	DDCAPS TYPEDEF DDCAPS_DX3
ELSEIF DIRECTDRAW_VERSION LE 0500h
	DDCAPS TYPEDEF DDCAPS_DX5
ELSEIF DIRECTDRAW_VERSION LE 0600h
	DDCAPS TYPEDEF DDCAPS_DX6
ELSE
	DDCAPS TYPEDEF DDCAPS_DX7
ENDIF

LPDDCAPS TYPEDEF PTR DDCAPS

; #############
; DDPIXELFORMAT
; #############

DDPIXELFORMAT	STRUCT
	dwSize						DWORD	?	; size of structure
	dwFlags						DWORD	?	; pixel format flags
	dwFourCC					DWORD	?	; (FOURCC code)
	UNION
		dwRGBBitCount			DWORD	?	; how many bits per pixel
		dwYUVBitCount			DWORD	?	; how many bits per pixel
		dwZBufferBitDepth		DWORD	?	; how many total bits/pixel in z buffer (including any stencil bits)
		dwAlphaBitDepth			DWORD	?	; how many bits for alpha channels
		dwLuminanceBitCount		DWORD	?	; how many bits per pixel
		dwBumpBitCount			DWORD	?	; how many bits per "buxel", total
		dwPrivateFormatBitCount	DWORD	?	; Bits per pixel of private driver formats. Only valid in texture
											;  format list and if DDPF_D3DFORMAT is set
	ENDS
	UNION
		dwRBitMask				DWORD	?	; mask for red bit
		dwYBitMask				DWORD	?	; mask for Y bits
		dwStencilBitDepth		DWORD	?	; how many stencil bits (note: dwZBufferBitDepth-dwStencilBitDepth is total Z-only bits)
		dwLuminanceBitMask		DWORD	?	; mask for luminance bits
		dwBumpDuBitMask			DWORD	?	; mask for bump map U delta bits
		dwOperations			DWORD	?	; DDPF_D3DFORMAT Operations
	ENDS
	UNION
		dwGBitMask				DWORD	?	; mask for green bits
		dwUBitMask				DWORD	?	; mask for U bits
		dwZBitMask				DWORD	?	; mask for Z bits
		dwBumpDvBitMask			DWORD	?	; mask for bump map V delta bits
		STRUCT
			wFlipMSTypes		WORD	?	; Multisample methods supported via flip for this D3DFORMAT
			wBltMSTypes			WORD	?	; Multisample methods supported via blt for this D3DFORMAT
		ENDS
	ENDS
	UNION
		dwBBitMask				DWORD	?	; mask for blue bits
		dwVBitMask				DWORD	?	; mask for V bits
		dwStencilBitMask		DWORD	?	; mask for stencil bits
		dwBumpLuminanceBitMask	DWORD	?	; mask for luminance in bump map
	ENDS
	UNION
		dwRGBAlphaBitMask		DWORD	?	; mask for alpha channel
		dwYUVAlphaBitMask		DWORD	?	; mask for alpha channel
		dwLuminanceAlphaBitMask	DWORD	?	; mask for alpha channel
		dwRGBZBitMask			DWORD	?	; mask for Z channel
		dwYUVZBitMask			DWORD	?	; mask for Z channel
	ENDS
DDPIXELFORMAT	ENDS

LPDDPIXELFORMAT TYPEDEF PTR DDPIXELFORMAT

; ###########
; DDOVERLAYFX
; ###########

DDOVERLAYFX STRUCT
	dwSize						DWORD	?					; size of structure
	dwAlphaEdgeBlendBitDepth	DWORD	?					; Bit depth used to specify constant for alpha edge blend
	dwAlphaEdgeBlend			DWORD	?					; Constant to use as alpha for edge blend
	dwReserved					DWORD	?					; 
	dwAlphaDestConstBitDepth	DWORD	?					; Bit depth used to specify alpha constant for destination
	UNION
		dwAlphaDestConst		DWORD	?					; Constant to use as alpha channel for dest
		lpDDSAlphaDest			LPDIRECTDRAWSURFACE		?	; Surface to use as alpha channel for dest
	ENDS
	dwAlphaSrcConstBitDepth		DWORD	?					; Bit depth used to specify alpha constant for source
	UNION
		dwAlphaSrcConst			DWORD	?					; Constant to use as alpha channel for src
		lpDDSAlphaSrc			LPDIRECTDRAWSURFACE		?	; Surface to use as alpha channel for src
	ENDS
	dckDestColorkey				DDCOLORKEY	<>				; DestColorkey override
	dckSrcColorkey				DDCOLORKEY	<>				; DestColorkey override
	dwDDFX						DWORD	?					; Overlay FX
	dwFlags						DWORD	?					; flags
DDOVERLAYFX ENDS

LPDDOVERLAYFX					TYPEDEF PTR DDOVERLAYFX

; ####################################
; DDBLTBATCH: BltBatch entry structure
; ####################################

DDBLTBATCH	STRUCT
	lprDest						LPRECT		?
	lpDDSSrc					LPDIRECTDRAWSURFACE	?
	lprSrc						LPRECT		?
	dwFlags						DWORD		?	
	lpDDBltFx					LPDDBLTFX	?
DDBLTBATCH ENDS

LPDDBLTBATCH 				TYPEDEF PTR DDBLTBATCH

; ###########
; DDGAMMARAMP
; ###########

DDGAMMARAMP	STRUC
    red		dw 256 dup (?)
    green	dw 256 dup (?)
    blue	dw 256 dup (?)
DDGAMMARAMP	ENDS

LPDDGAMMARAMP				TYPEDEF PTR DDGAMMARAMP

;##################
;DDDEVICEIDENTIFIER
;##################

MAX_DDDEVICEID_STRING           		EQU 512
; ########################################################################################################
; This is the structure within which DirectDraw returns data about the current graphics driver and chipset
; ########################################################################################################

DDDEVICEIDENTIFIER STRUCT

	; These elements are for presentation to the user only. They should not be used to identify particular
	; drivers, since this is unreliable and many different strings may be associated with the same
	; device, and the same driver from different vendors.

    szDriver				db MAX_DDDEVICEID_STRING dup (?)
    szDescription			db MAX_DDDEVICEID_STRING dup (?)

	; This element is the version of the DirectDraw/3D driver. It is legal to do <, > comparisons
	; on the whole 64 bits. Caution should be exercised if you use this element to identify problematic
	; drivers. It is recommended that guidDeviceIdentifier is used for this purpose.
;
	; This version has the form:
	;  wProduct = HIWORD(liDriverVersion.HighPart)
	;  wVersion = LOWORD(liDriverVersion.HighPart)
	;  wSubVersion = HIWORD(liDriverVersion.LowPart)
	;  wBuild = LOWORD(liDriverVersion.LowPart)

    liDriverVersion			LARGE_INTEGER <?>

	; These elements can be used to identify particular chipsets. Use with extreme caution.
	;   dwVendorId     Identifies the manufacturer. May be zero if unknown.
	;   dwDeviceId     Identifies the type of chipset. May be zero if unknown.
	;   dwSubSysId     Identifies the subsystem, typically this means the particular board. May be zero if unknown.
	;   dwRevision     Identifies the revision level of the chipset. May be zero if unknown.

    dwVendorId				DWORD ?
    dwDeviceId				DWORD ?
    dwSubSysId				DWORD ?
    dwRevision				DWORD ?

	; This element can be used to check changes in driver/chipset. This GUID is a unique identifier for the
	; driver/chipset pair. Use this element if you wish to track changes to the driver/chipset in order to
	; reprofile the graphics subsystem.
	; This element can also be used to identify particular problematic drivers.

    guidDeviceIdentifier	GUID <>
DDDEVICEIDENTIFIER ENDS

LPDDDEVICEIDENTIFIER TYPEDEF PTR DDDEVICEIDENTIFIER

DDDEVICEIDENTIFIER2 STRUCT

	; These elements are for presentation to the user only. They should not be used to identify particular
	; drivers, since this is unreliable and many different strings may be associated with the same
	; device, and the same driver from different vendors.

    szDriver				db MAX_DDDEVICEID_STRING dup (?)
    szDescription			db MAX_DDDEVICEID_STRING dup (?)

	; This element is the version of the DirectDraw/3D driver. It is legal to do <, > comparisons
	; on the whole 64 bits. Caution should be exercised if you use this element to identify problematic
	; drivers. It is recommended that guidDeviceIdentifier is used for this purpose.
;
	; This version has the form:
	;  wProduct = HIWORD(liDriverVersion.HighPart)
	;  wVersion = LOWORD(liDriverVersion.HighPart)
	;  wSubVersion = HIWORD(liDriverVersion.LowPart)
	;  wBuild = LOWORD(liDriverVersion.LowPart)

    liDriverVersion			LARGE_INTEGER <?>

	; These elements can be used to identify particular chipsets. Use with extreme caution.
	;   dwVendorId     Identifies the manufacturer. May be zero if unknown.
	;   dwDeviceId     Identifies the type of chipset. May be zero if unknown.
	;   dwSubSysId     Identifies the subsystem, typically this means the particular board. May be zero if unknown.
	;   dwRevision     Identifies the revision level of the chipset. May be zero if unknown.

    dwVendorId				DWORD ?
    dwDeviceId				DWORD ?
    dwSubSysId				DWORD ?
    dwRevision				DWORD ?

	; This element can be used to check changes in driver/chipset. This GUID is a unique identifier for the
	; driver/chipset pair. Use this element if you wish to track changes to the driver/chipset in order to
	; reprofile the graphics subsystem.
	; This element can also be used to identify particular problematic drivers.

    guidDeviceIdentifier	GUID <>

	; This element is used to determine the Windows Hardware Quality Lab (WHQL)
	; certification level for this driver/device pair.

    dwWHQLLevel 			DWORD ?
DDDEVICEIDENTIFIER2 ENDS

LPDDDEVICEIDENTIFIER2 TYPEDEF PTR DDDEVICEIDENTIFIER2

; ######################################################
; Flags for the IDirectDraw4::GetDeviceIdentifier method
; ######################################################

; This flag causes GetDeviceIdentifier to return information about the host (typically 2D) adapter in a system equipped
; with a stacked secondary 3D adapter. Such an adapter appears to the application as if it were part of the
; host adapter, but is typically physcially located on a separate card. The stacked secondary's information is
; returned when GetDeviceIdentifier's dwFlags field is zero, since this most accurately reflects the qualities
; of the DirectDraw object involved.

DDGDI_GETHOSTIDENTIFIER         		EQU 00000001h

; #######################################################
; Macros for interpretting DDEVICEIDENTIFIER2.dwWHQLLevel
; #######################################################

GET_WHQL_YEAR MACRO dwWHQLLevel:REQ
	mov eax, dwWHQLLevel
	shr eax, 16
ENDM

GET_WHQL_MONTH MACRO dwWHQLLevel:REQ
	mov eax, dwWHQLLevel
	mov al, ah
	and eax, 0FFh
ENDM

GET_WHQL_DAY MACRO dwWHQLLevel:REQ
	mov eax, dwWHQLLevel
	and eax, 0FFh
ENDM

; #########
; callbacks
; #########

LPCLIPPERCALLBACK			TYPEDEF DWORD

IFDEF STREAMING
LPSURFACESTREAMINGCALLBACK	TYPEDEF DWORD
ENDIF

; #######################
; INTERFACES FOLLOW:
;      IDirectDraw
;      IDirectDrawClipper
;      IDirectDrawPalette
;      IDirectDrawSurface
; #######################

; ###########
; IDirectDraw
; ###########

IDirectDrawVtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDraw, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDraw
	STDMETHOD	Release, 				:PTR IDirectDraw
	; IDirectDraw methods
	STDMETHOD	Compact, 				:PTR IDirectDraw
	STDMETHOD	CreateClipper, 			:PTR IDirectDraw, :DWORD, :PTR LPDIRECTDRAWCLIPPER, :PTR IUnknown
	STDMETHOD	CreatePalette, 			:PTR IDirectDraw, :DWORD, :LPPALETTEENTRY, :PTR LPDIRECTDRAWPALETTE, :PTR IUnknown
	STDMETHOD	CreateSurface, 			:PTR IDirectDraw, :LPDDSURFACEDESC, :PTR LPDIRECTDRAWSURFACE, :PTR IUnknown
	STDMETHOD	DuplicateSurface, 		:PTR IDirectDraw, :LPDIRECTDRAWSURFACE, :PTR LPDIRECTDRAWSURFACE
	STDMETHOD	EnumDisplayModes, 		:PTR IDirectDraw, :DWORD, :LPDDSURFACEDESC, :LPVOID, :LPDDENUMMODESCALLBACK
	STDMETHOD	EnumSurfaces, 			:PTR IDirectDraw, :DWORD, :LPDDSURFACEDESC, :LPVOID, :LPDDENUMSURFACESCALLBACK
	STDMETHOD	FlipToGDISurface, 		:PTR IDirectDraw
	STDMETHOD	GetCaps, 				:PTR IDirectDraw, :LPDDCAPS, :LPDDCAPS
	STDMETHOD	GetDisplayMode, 		:PTR IDirectDraw, :LPDDSURFACEDESC
	STDMETHOD	GetFourCCCodes, 		:PTR IDirectDraw, :LPDWORD, :LPDWORD
	STDMETHOD	GetGDISurface, 			:PTR IDirectDraw, :PTR LPDIRECTDRAWSURFACE
	STDMETHOD	GetMonitorFrequency, 	:PTR IDirectDraw, :LPDWORD
	STDMETHOD	GetScanLine, 			:PTR IDirectDraw, :LPDWORD
	STDMETHOD	GetVerticalBlankStatus, :PTR IDirectDraw, :LPBOOL
	STDMETHOD	Initialize, 			:PTR IDirectDraw, :PTR GUID
	STDMETHOD	RestoreDisplayMode, 	:PTR IDirectDraw
	STDMETHOD	SetCooperativeLevel, 	:PTR IDirectDraw, :HWND, :DWORD
	STDMETHOD	SetDisplayMode, 		:PTR IDirectDraw, :DWORD, :DWORD, :DWORD
	STDMETHOD	WaitForVerticalBlank, 	:PTR IDirectDraw, :DWORD, :HANDLE
IDirectDrawVtbl ENDS

IDirectDraw STRUCT
	lpVtbl DWORD ?
IDirectDraw ENDS

; ############
; IDirectDraw2
; ############

IDirectDraw2Vtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDraw2, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDraw2
	STDMETHOD	Release, 				:PTR IDirectDraw2
	; IDirectDraw methods
	STDMETHOD	Compact, 				:PTR IDirectDraw2
	STDMETHOD	CreateClipper, 			:PTR IDirectDraw2, :DWORD, :PTR LPDIRECTDRAWCLIPPER, :PTR IUnknown
	STDMETHOD	CreatePalette, 			:PTR IDirectDraw2, :DWORD, :LPPALETTEENTRY, :PTR LPDIRECTDRAWPALETTE, :PTR IUnknown
	STDMETHOD	CreateSurface, 			:PTR IDirectDraw2, :LPDDSURFACEDESC, :PTR LPDIRECTDRAWSURFACE, :PTR IUnknown
	STDMETHOD	DuplicateSurface, 		:PTR IDirectDraw2, :LPDIRECTDRAWSURFACE, :PTR LPDIRECTDRAWSURFACE
	STDMETHOD	EnumDisplayModes, 		:PTR IDirectDraw2, :DWORD, :LPDDSURFACEDESC, :LPVOID, :LPDDENUMMODESCALLBACK
	STDMETHOD	EnumSurfaces, 			:PTR IDirectDraw2, :DWORD, :LPDDSURFACEDESC, :LPVOID, :LPDDENUMSURFACESCALLBACK
	STDMETHOD	FlipToGDISurface, 		:PTR IDirectDraw2
	STDMETHOD	GetCaps, 				:PTR IDirectDraw2, :LPDDCAPS, :LPDDCAPS
	STDMETHOD	GetDisplayMode, 		:PTR IDirectDraw2, :LPDDSURFACEDESC
	STDMETHOD	GetFourCCCodes, 		:PTR IDirectDraw2, :LPDWORD, :LPDWORD
	STDMETHOD	GetGDISurface, 			:PTR IDirectDraw2, :PTR LPDIRECTDRAWSURFACE
	STDMETHOD	GetMonitorFrequency, 	:PTR IDirectDraw2, :LPDWORD
	STDMETHOD	GetScanLine, 			:PTR IDirectDraw2, :LPDWORD
	STDMETHOD	GetVerticalBlankStatus, :PTR IDirectDraw2, :LPBOOL
	STDMETHOD	Initialize, 			:PTR IDirectDraw2, :PTR GUID
	STDMETHOD	RestoreDisplayMode, 	:PTR IDirectDraw2
	STDMETHOD	SetCooperativeLevel, 	:PTR IDirectDraw2, :HWND, :DWORD
	STDMETHOD	SetDisplayMode, 		:PTR IDirectDraw2, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
	STDMETHOD	WaitForVerticalBlank, 	:PTR IDirectDraw2, :DWORD, :HANDLE
	; Added in the v2 interface
	STDMETHOD   GetAvailableVidMem, 	:PTR IDirectDraw2, :LPDDSCAPS, :LPDWORD, :LPDWORD
IDirectDraw2Vtbl ENDS

IDirectDraw2 STRUCT
	lpVtbl DWORD ?
IDirectDraw2 ENDS

; ############
; IDirectDraw4
; ############

IDirectDraw4Vtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDraw4, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDraw4
	STDMETHOD	Release, 				:PTR IDirectDraw4
	; IDirectDraw methods
	STDMETHOD	Compact, 				:PTR IDirectDraw4
	STDMETHOD	CreateClipper, 			:PTR IDirectDraw4, :DWORD, :PTR LPDIRECTDRAWCLIPPER, :PTR IUnknown
	STDMETHOD	CreatePalette, 			:PTR IDirectDraw4, :DWORD, :LPPALETTEENTRY, :PTR LPDIRECTDRAWPALETTE, :PTR IUnknown
	STDMETHOD	CreateSurface, 			:PTR IDirectDraw4, :LPDDSURFACEDESC2, :PTR LPDIRECTDRAWSURFACE4, :PTR IUnknown
	STDMETHOD	DuplicateSurface, 		:PTR IDirectDraw4, :LPDIRECTDRAWSURFACE4, :PTR LPDIRECTDRAWSURFACE4
	STDMETHOD	EnumDisplayModes, 		:PTR IDirectDraw4, :DWORD, :LPDDSURFACEDESC2, :LPVOID, :LPDDENUMMODESCALLBACK2
	STDMETHOD	EnumSurfaces, 			:PTR IDirectDraw4, :DWORD, :LPDDSURFACEDESC2, :LPVOID, :LPDDENUMSURFACESCALLBACK2
	STDMETHOD	FlipToGDISurface, 		:PTR IDirectDraw4
	STDMETHOD	GetCaps, 				:PTR IDirectDraw4, :LPDDCAPS, :LPDDCAPS
	STDMETHOD	GetDisplayMode, 		:PTR IDirectDraw4, :LPDDSURFACEDESC2
	STDMETHOD	GetFourCCCodes, 		:PTR IDirectDraw4, :LPDWORD, :LPDWORD
	STDMETHOD	GetGDISurface, 			:PTR IDirectDraw4, :PTR LPDIRECTDRAWSURFACE4
	STDMETHOD	GetMonitorFrequency, 	:PTR IDirectDraw4, :LPDWORD
	STDMETHOD	GetScanLine, 			:PTR IDirectDraw4, :LPDWORD
	STDMETHOD	GetVerticalBlankStatus, :PTR IDirectDraw4, :LPBOOL
	STDMETHOD	Initialize, 			:PTR IDirectDraw4, :PTR GUID
	STDMETHOD	RestoreDisplayMode, 	:PTR IDirectDraw4
	STDMETHOD	SetCooperativeLevel, 	:PTR IDirectDraw4, :HWND, :DWORD
	STDMETHOD	SetDisplayMode, 		:PTR IDirectDraw4, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
	STDMETHOD	WaitForVerticalBlank, 	:PTR IDirectDraw4, :DWORD, :HANDLE
	; Added in the v2 interface
	STDMETHOD   GetAvailableVidMem, 	:PTR IDirectDraw4, :LPDDSCAPS2, :LPDWORD, :LPDWORD
	; Added in the v4 interface
	STDMETHOD   GetSurfaceFromDC,       :PTR IDirectDraw4, :HDC, :LPDIRECTDRAWSURFACE4
	STDMETHOD   RestoreAllSurfaces,		:PTR IDirectDraw4
	STDMETHOD   TestCooperativeLevel,	:PTR IDirectDraw4
	STDMETHOD   GetDeviceIdentifier,	:PTR IDirectDraw4, :LPDDDEVICEIDENTIFIER, :DWORD
IDirectDraw4Vtbl ENDS

IDirectDraw4 STRUCT
	lpVtbl DWORD ?
IDirectDraw4 ENDS

;############
;IDirectDraw7
;############

IDirectDraw7Vtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDraw7, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDraw7
	STDMETHOD	Release, 				:PTR IDirectDraw7
	; IDirectDraw methods
	STDMETHOD	Compact, 				:PTR IDirectDraw7
	STDMETHOD	CreateClipper, 			:PTR IDirectDraw7, :DWORD, :PTR LPDIRECTDRAWCLIPPER, :PTR IUnknown
	STDMETHOD	CreatePalette, 			:PTR IDirectDraw7, :DWORD, :LPPALETTEENTRY, :PTR LPDIRECTDRAWPALETTE, :PTR IUnknown
	STDMETHOD	CreateSurface, 			:PTR IDirectDraw7, :LPDDSURFACEDESC2, :PTR LPDIRECTDRAWSURFACE7, :PTR IUnknown
	STDMETHOD	DuplicateSurface, 		:PTR IDirectDraw7, :LPDIRECTDRAWSURFACE7, :PTR LPDIRECTDRAWSURFACE7
	STDMETHOD	EnumDisplayModes, 		:PTR IDirectDraw7, :DWORD, :LPDDSURFACEDESC2, :LPVOID, :LPDDENUMMODESCALLBACK2
	STDMETHOD	EnumSurfaces, 			:PTR IDirectDraw7, :DWORD, :LPDDSURFACEDESC2, :LPVOID, :LPDDENUMSURFACESCALLBACK7
	STDMETHOD	FlipToGDISurface, 		:PTR IDirectDraw7
	STDMETHOD	GetCaps, 				:PTR IDirectDraw7, :LPDDCAPS, :LPDDCAPS
	STDMETHOD	GetDisplayMode, 		:PTR IDirectDraw7, :LPDDSURFACEDESC2
	STDMETHOD	GetFourCCCodes, 		:PTR IDirectDraw7, :LPDWORD, :LPDWORD
	STDMETHOD	GetGDISurface, 			:PTR IDirectDraw7, :PTR LPDIRECTDRAWSURFACE7
	STDMETHOD	GetMonitorFrequency, 	:PTR IDirectDraw7, :LPDWORD
	STDMETHOD	GetScanLine, 			:PTR IDirectDraw7, :LPDWORD
	STDMETHOD	GetVerticalBlankStatus, :PTR IDirectDraw7, :LPBOOL
	STDMETHOD	Initialize,		 		:PTR IDirectDraw7, :PTR GUID
	STDMETHOD	RestoreDisplayMode, 	:PTR IDirectDraw7
	STDMETHOD	SetCooperativeLevel, 	:PTR IDirectDraw7, :HWND, :DWORD
	STDMETHOD	SetDisplayMode, 		:PTR IDirectDraw7, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
	STDMETHOD	WaitForVerticalBlank, 	:PTR IDirectDraw7, :DWORD, :HANDLE
	; Added in the v2 interface
	STDMETHOD   GetAvailableVidMem, 	:PTR IDirectDraw7, :LPDDSCAPS2, :LPDWORD, :LPDWORD
	; Added in the v4 Interface
	STDMETHOD   GetSurfaceFromDC,       :PTR IDirectDraw7, :HDC, :LPDIRECTDRAWSURFACE7
	STDMETHOD   RestoreAllSurfaces,		:PTR IDirectDraw7
	STDMETHOD   TestCooperativeLevel,	:PTR IDirectDraw7
	STDMETHOD   GetDeviceIdentifier,	:PTR IDirectDraw7, :LPDDDEVICEIDENTIFIER2, :DWORD
	; Added in the v7 Interface
    STDMETHOD   StartModeTest,			:PTR IDirectDraw7, :LPSIZE, :DWORD, :DWORD
    STDMETHOD   EvaluateMode,			:PTR IDirectDraw7, :DWORD, :PTR DWORD
IDirectDraw7Vtbl ENDS

IDirectDraw7 STRUCT
	lpVtbl DWORD ?
IDirectDraw7 ENDS

; ##################
; IDirectDrawPalette
; ##################

IDirectDrawPaletteVtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDrawPalette, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDrawPalette
	STDMETHOD	Release, 				:PTR IDirectDrawPalette
	; IDirectDrawPalette methods
	STDMETHOD	GetCaps, 				:PTR IDirectDrawPalette, :LPDWORD
	STDMETHOD	GetEntries, 			:PTR IDirectDrawPalette, :DWORD, :DWORD, :DWORD, :LPPALETTEENTRY
	STDMETHOD	Initialize,				:PTR IDirectDrawPalette, :LPDIRECTDRAW, :DWORD, :LPPALETTEENTRY
	STDMETHOD	SetEntries, 			:PTR IDirectDrawPalette, :DWORD, :DWORD, :DWORD, :LPPALETTEENTRY
IDirectDrawPaletteVtbl ENDS

IDirectDrawPalette STRUCT
	lpVtbl DWORD ?
IDirectDrawPalette ENDS

; ##################
; IDirectDrawClipper
; ##################

IDirectDrawClipperVtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDrawClipper, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDrawClipper
	STDMETHOD	Release, 				:PTR IDirectDrawClipper
	; IDirectDrawClipper methods
	STDMETHOD	GetClipList, 			:PTR IDirectDrawClipper, :LPRECT, :LPRGNDATA, :LPDWORD
	STDMETHOD	GetHWnd, 				:PTR IDirectDrawClipper, :PTR HWND
	STDMETHOD	Initialize, 			:PTR IDirectDrawClipper, :LPDIRECTDRAW, :DWORD
	STDMETHOD	IsClipListChanged, 		:PTR IDirectDrawClipper, :PTR BOOL
	STDMETHOD	SetClipList, 			:PTR IDirectDrawClipper, :LPRGNDATA, :DWORD
	STDMETHOD	SetHWnd, 				:PTR IDirectDrawClipper, :DWORD, :HWND
IDirectDrawClipperVtbl ENDS

IDirectDrawClipper STRUCT
	lpVtbl DWORD ?
IDirectDrawClipper ENDS

; #########################################
; IDirectDrawSurface and related interfaces
; #########################################

IDirectDrawSurfaceVtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDrawSurface, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDrawSurface
	STDMETHOD	Release,		 		:PTR IDirectDrawSurface
	; IDirectDrawSurface methods
	STDMETHOD	AddAttachedSurface, 	:PTR IDirectDrawSurface, :LPDIRECTDRAWSURFACE
	STDMETHOD	AddOverlayDirtyRect, 	:PTR IDirectDrawSurface, :LPRECT
	STDMETHOD	Blt, 					:PTR IDirectDrawSurface, :LPRECT, :LPDIRECTDRAWSURFACE, :LPRECT, :DWORD, :LPDDBLTFX
	STDMETHOD	BltBatch, 				:PTR IDirectDrawSurface, :LPDDBLTBATCH, :DWORD, :DWORD
	STDMETHOD	BltFast, 				:PTR IDirectDrawSurface, :DWORD, :DWORD, :LPDIRECTDRAWSURFACE, :LPRECT, :DWORD
	STDMETHOD	DeleteAttachedSurface, 	:PTR IDirectDrawSurface, :DWORD, :LPDIRECTDRAWSURFACE
	STDMETHOD	EnumAttachedSurfaces, 	:PTR IDirectDrawSurface, :LPVOID, :LPDDENUMSURFACESCALLBACK
	STDMETHOD	EnumOverlayZOrders, 	:PTR IDirectDrawSurface, :DWORD, :LPVOID , :LPDDENUMSURFACESCALLBACK
	STDMETHOD	Flip, 					:PTR IDirectDrawSurface, :LPDIRECTDRAWSURFACE, :DWORD
	STDMETHOD	GetAttachedSurface, 	:PTR IDirectDrawSurface, :LPDDSCAPS, :PTR LPDIRECTDRAWSURFACE
	STDMETHOD	GetBltStatus, 			:PTR IDirectDrawSurface, :DWORD
	STDMETHOD	GetCaps, 				:PTR IDirectDrawSurface, :LPDDSCAPS
	STDMETHOD	GetClipper, 			:PTR IDirectDrawSurface, :PTR LPDIRECTDRAWCLIPPER
	STDMETHOD	GetColorKey, 			:PTR IDirectDrawSurface, :DWORD, :LPDDCOLORKEY
	STDMETHOD	GetDC, 					:PTR IDirectDrawSurface, :PTR HDC
	STDMETHOD	GetFlipStatus, 			:PTR IDirectDrawSurface, :DWORD
	STDMETHOD	GetOverlayPosition, 	:PTR IDirectDrawSurface, :LPLONG, :LPLONG
	STDMETHOD	GetPalette, 			:PTR IDirectDrawSurface, :PTR LPDIRECTDRAWPALETTE
	STDMETHOD	GetPixelFormat, 		:PTR IDirectDrawSurface, :LPDDPIXELFORMAT
	STDMETHOD	GetSurfaceDesc, 		:PTR IDirectDrawSurface, :LPDDSURFACEDESC
	STDMETHOD	Initialize, 			:PTR IDirectDrawSurface, :LPDIRECTDRAW, :LPDDSURFACEDESC
	STDMETHOD	IsLost, 				:PTR IDirectDrawSurface
	STDMETHOD	_Lock, 					:PTR IDirectDrawSurface, :LPRECT, :LPDDSURFACEDESC, :DWORD, :HANDLE 
	STDMETHOD	ReleaseDC, 				:PTR IDirectDrawSurface, :HDC
	STDMETHOD	Restore, 				:PTR IDirectDrawSurface
	STDMETHOD	SetClipper, 			:PTR IDirectDrawSurface, :LPDIRECTDRAWCLIPPER
	STDMETHOD	SetColorKey, 			:PTR IDirectDrawSurface, :DWORD, :LPDDCOLORKEY
	STDMETHOD	SetOverlayPosition, 	:PTR IDirectDrawSurface, :LONG, :LONG
	STDMETHOD	SetPalette, 			:PTR IDirectDrawSurface, :LPDIRECTDRAWPALETTE
	STDMETHOD	Unlock, 				:PTR IDirectDrawSurface, :LPVOID 
	STDMETHOD	UpdateOverlay, 			:PTR IDirectDrawSurface, :LPRECT, :LPDIRECTDRAWSURFACE, :LPRECT, :DWORD, :LPDDOVERLAYFX
	STDMETHOD	UpdateOverlayDisplay, 	:PTR IDirectDrawSurface, :DWORD
	STDMETHOD	UpdateOverlayZOrder, 	:PTR IDirectDrawSurface, :DWORD, :LPDIRECTDRAWSURFACE
IDirectDrawSurfaceVtbl ENDS

IDirectDrawSurface STRUCT
	lpVtbl DWORD ?
IDirectDrawSurface ENDS

;##########################################0
;IDirectDrawSurface2 and related interfaces
;##########################################

IDirectDrawSurface2Vtbl	STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDrawSurface2, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDrawSurface2
	STDMETHOD	Release,		 		:PTR IDirectDrawSurface2
	; IDirectDrawSurface methods
	STDMETHOD	AddAttachedSurface, 	:PTR IDirectDrawSurface2, :LPDIRECTDRAWSURFACE2
	STDMETHOD	AddOverlayDirtyRect, 	:PTR IDirectDrawSurface2, :LPRECT
	STDMETHOD	Blt, 					:PTR IDirectDrawSurface2, :LPRECT, :LPDIRECTDRAWSURFACE2, :LPRECT, :DWORD, :LPDDBLTFX
	STDMETHOD	BltBatch, 				:PTR IDirectDrawSurface2, :LPDDBLTBATCH, :DWORD, :DWORD
	STDMETHOD	BltFast, 				:PTR IDirectDrawSurface2, :DWORD, :DWORD, :LPDIRECTDRAWSURFACE2, :LPRECT, :DWORD
	STDMETHOD	DeleteAttachedSurface, 	:PTR IDirectDrawSurface2, :DWORD, :LPDIRECTDRAWSURFACE2
	STDMETHOD	EnumAttachedSurfaces, 	:PTR IDirectDrawSurface2, :LPVOID, :LPDDENUMSURFACESCALLBACK
	STDMETHOD	EnumOverlayZOrders, 	:PTR IDirectDrawSurface2, :DWORD, :LPVOID , :LPDDENUMSURFACESCALLBACK
	STDMETHOD	Flip, 					:PTR IDirectDrawSurface2, :LPDIRECTDRAWSURFACE2, :DWORD
	STDMETHOD	GetAttachedSurface, 	:PTR IDirectDrawSurface2, :LPDDSCAPS, :PTR LPDIRECTDRAWSURFACE2
	STDMETHOD	GetBltStatus, 			:PTR IDirectDrawSurface2, :DWORD
	STDMETHOD	GetCaps, 				:PTR IDirectDrawSurface2, :LPDDSCAPS
	STDMETHOD	GetClipper, 			:PTR IDirectDrawSurface2, :PTR LPDIRECTDRAWCLIPPER
	STDMETHOD	GetColorKey, 			:PTR IDirectDrawSurface2, :DWORD, :LPDDCOLORKEY
	STDMETHOD	GetDC, 					:PTR IDirectDrawSurface2, :PTR HDC
	STDMETHOD	GetFlipStatus, 			:PTR IDirectDrawSurface2, :DWORD
	STDMETHOD	GetOverlayPosition, 	:PTR IDirectDrawSurface2, :LPLONG, :LPLONG
	STDMETHOD	GetPalette, 			:PTR IDirectDrawSurface2, :PTR LPDIRECTDRAWPALETTE
	STDMETHOD	GetPixelFormat, 		:PTR IDirectDrawSurface2, :LPDDPIXELFORMAT
	STDMETHOD	GetSurfaceDesc, 		:PTR IDirectDrawSurface2, :LPDDSURFACEDESC
	STDMETHOD	Initialize, 			:PTR IDirectDrawSurface2, :LPDIRECTDRAW, :LPDDSURFACEDESC
	STDMETHOD	IsLost, 				:PTR IDirectDrawSurface2
	STDMETHOD	_Lock, 					:PTR IDirectDrawSurface2, :LPRECT, :LPDDSURFACEDESC, :DWORD, :HANDLE 
	STDMETHOD	ReleaseDC, 				:PTR IDirectDrawSurface2, :HDC
	STDMETHOD	Restore, 				:PTR IDirectDrawSurface2
	STDMETHOD	SetClipper, 			:PTR IDirectDrawSurface2, :LPDIRECTDRAWCLIPPER
	STDMETHOD	SetColorKey, 			:PTR IDirectDrawSurface2, :DWORD, :LPDDCOLORKEY
	STDMETHOD	SetOverlayPosition, 	:PTR IDirectDrawSurface2, :LONG, :LONG
	STDMETHOD	SetPalette, 			:PTR IDirectDrawSurface2, :LPDIRECTDRAWPALETTE
	STDMETHOD	Unlock, 				:PTR IDirectDrawSurface2, :LPVOID
	STDMETHOD	UpdateOverlay, 			:PTR IDirectDrawSurface2, :LPRECT, :LPDIRECTDRAWSURFACE2, :LPRECT, :DWORD, :LPDDOVERLAYFX
	STDMETHOD	UpdateOverlayDisplay, 	:PTR IDirectDrawSurface2, :DWORD
	STDMETHOD	UpdateOverlayZOrder, 	:PTR IDirectDrawSurface2, :DWORD, :LPDIRECTDRAWSURFACE2
    ; Added in the v2 interface
   	STDMETHOD   GetDDInterface,			:PTR IDirectDrawSurface2, :PTR LPVOID
   	STDMETHOD   PageLock,				:PTR IDirectDrawSurface2, :DWORD
   	STDMETHOD   PageUnlock,				:PTR IDirectDrawSurface2, :DWORD
IDirectDrawSurface2Vtbl	ENDS

IDirectDrawSurface2	STRUCT
	lpVtbl DWORD ?
IDirectDrawSurface2	ENDS

; ##########################################
; IDirectDrawSurface3 and related interfaces
; ##########################################

IDirectDrawSurface3Vtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDrawSurface3, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDrawSurface3
	STDMETHOD	Release,		 		:PTR IDirectDrawSurface3
	; IDirectDrawSurface methods
	STDMETHOD	AddAttachedSurface, 	:PTR IDirectDrawSurface3, :LPDIRECTDRAWSURFACE3
	STDMETHOD	AddOverlayDirtyRect, 	:PTR IDirectDrawSurface3, :LPRECT
	STDMETHOD	Blt, 					:PTR IDirectDrawSurface3, :LPRECT, :LPDIRECTDRAWSURFACE3, :LPRECT, :DWORD, :LPDDBLTFX
	STDMETHOD	BltBatch, 				:PTR IDirectDrawSurface3, :LPDDBLTBATCH, :DWORD, :DWORD
	STDMETHOD	BltFast, 				:PTR IDirectDrawSurface3, :DWORD, :DWORD, :LPDIRECTDRAWSURFACE3, :LPRECT, :DWORD
	STDMETHOD	DeleteAttachedSurface, 	:PTR IDirectDrawSurface3, :DWORD, :LPDIRECTDRAWSURFACE3
	STDMETHOD	EnumAttachedSurfaces, 	:PTR IDirectDrawSurface3, :LPVOID, :LPDDENUMSURFACESCALLBACK
	STDMETHOD	EnumOverlayZOrders, 	:PTR IDirectDrawSurface3, :DWORD, :LPVOID, :LPDDENUMSURFACESCALLBACK
	STDMETHOD	Flip, 					:PTR IDirectDrawSurface3, :LPDIRECTDRAWSURFACE3, :DWORD
	STDMETHOD	GetAttachedSurface, 	:PTR IDirectDrawSurface3, :LPDDSCAPS, :PTR LPDIRECTDRAWSURFACE3
	STDMETHOD	GetBltStatus, 			:PTR IDirectDrawSurface3, :DWORD
	STDMETHOD	GetCaps, 				:PTR IDirectDrawSurface3, :LPDDSCAPS
	STDMETHOD	GetClipper, 			:PTR IDirectDrawSurface3, :PTR LPDIRECTDRAWCLIPPER
	STDMETHOD	GetColorKey, 			:PTR IDirectDrawSurface3, :DWORD, :LPDDCOLORKEY
	STDMETHOD	GetDC, 					:PTR IDirectDrawSurface3, :PTR HDC
	STDMETHOD	GetFlipStatus, 			:PTR IDirectDrawSurface3, :DWORD
	STDMETHOD	GetOverlayPosition, 	:PTR IDirectDrawSurface3, :LPLONG, :LPLONG
	STDMETHOD	GetPalette, 			:PTR IDirectDrawSurface3, :PTR LPDIRECTDRAWPALETTE
	STDMETHOD	GetPixelFormat, 		:PTR IDirectDrawSurface3, :LPDDPIXELFORMAT
	STDMETHOD	GetSurfaceDesc, 		:PTR IDirectDrawSurface3, :LPDDSURFACEDESC
	STDMETHOD	Initialize, 			:PTR IDirectDrawSurface3, :LPDIRECTDRAW, :LPDDSURFACEDESC
	STDMETHOD	IsLost, 				:PTR IDirectDrawSurface3
	STDMETHOD	mLock, 					:PTR IDirectDrawSurface3, :LPRECT, :LPDDSURFACEDESC, :DWORD, :HANDLE 
	STDMETHOD	ReleaseDC, 				:PTR IDirectDrawSurface3, :HDC
	STDMETHOD	Restore, 				:PTR IDirectDrawSurface3
	STDMETHOD	SetClipper, 			:PTR IDirectDrawSurface3, :LPDIRECTDRAWCLIPPER
	STDMETHOD	SetColorKey, 			:PTR IDirectDrawSurface3, :DWORD, :LPDDCOLORKEY
	STDMETHOD	SetOverlayPosition, 	:PTR IDirectDrawSurface3, :LONG, :LONG
	STDMETHOD	SetPalette, 			:PTR IDirectDrawSurface3, :LPDIRECTDRAWPALETTE
	STDMETHOD	Unlock, 				:PTR IDirectDrawSurface3, :LPVOID 
	STDMETHOD	UpdateOverlay, 			:PTR IDirectDrawSurface3, :LPRECT, :LPDIRECTDRAWSURFACE3, :LPRECT, :DWORD, :LPDDOVERLAYFX
	STDMETHOD	UpdateOverlayDisplay, 	:PTR IDirectDrawSurface3, :DWORD
	STDMETHOD	UpdateOverlayZOrder, 	:PTR IDirectDrawSurface3, :DWORD, :LPDIRECTDRAWSURFACE3
    ; Added in the v2 interface
	STDMETHOD   GetDDInterface,			:PTR IDirectDrawSurface3, :PTR LPVOID
	STDMETHOD   PageLock,				:PTR IDirectDrawSurface3, :DWORD
	STDMETHOD   PageUnlock,				:PTR IDirectDrawSurface3, :DWORD
    ; Added in the v3 interface
	STDMETHOD	SetSurfaceDesc,			:PTR IDirectDrawSurface3, :LPDDSURFACEDESC, :DWORD
IDirectDrawSurface3Vtbl ENDS

IDirectDrawSurface3 STRUCT
	lpVtb DWORD ?
IDirectDrawSurface3 ENDS

; ##########################################
; IDirectDrawSurface4 and related interfaces
; ##########################################

IDirectDrawSurface4Vtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDrawSurface4, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDrawSurface4
	STDMETHOD	Release,		 		:PTR IDirectDrawSurface4
	; IDirectDrawSurface methods
	STDMETHOD	AddAttachedSurface, 	:PTR IDirectDrawSurface4, :LPDIRECTDRAWSURFACE4
	STDMETHOD	AddOverlayDirtyRect, 	:PTR IDirectDrawSurface4, :LPRECT
	STDMETHOD	Blt, 					:PTR IDirectDrawSurface4, :LPRECT, :LPDIRECTDRAWSURFACE4, :LPRECT, :DWORD, :LPDDBLTFX
	STDMETHOD	BltBatch, 				:PTR IDirectDrawSurface4, :LPDDBLTBATCH, :DWORD, :DWORD
	STDMETHOD	BltFast, 				:PTR IDirectDrawSurface4, :DWORD, :DWORD, :LPDIRECTDRAWSURFACE4, :LPRECT, :DWORD
	STDMETHOD	DeleteAttachedSurface, 	:PTR IDirectDrawSurface4, :DWORD, :LPDIRECTDRAWSURFACE4
	STDMETHOD	EnumAttachedSurfaces, 	:PTR IDirectDrawSurface4, :LPVOID, :LPDDENUMSURFACESCALLBACK2
	STDMETHOD	EnumOverlayZOrders, 	:PTR IDirectDrawSurface4, :DWORD, :LPVOID, :LPDDENUMSURFACESCALLBACK2
	STDMETHOD	Flip, 					:PTR IDirectDrawSurface4, :LPDIRECTDRAWSURFACE4, :DWORD
	STDMETHOD	GetAttachedSurface, 	:PTR IDirectDrawSurface4, :LPDDSCAPS2, :PTR LPDIRECTDRAWSURFACE4
	STDMETHOD	GetBltStatus,	 		:PTR IDirectDrawSurface4, :DWORD
	STDMETHOD	GetCaps, 				:PTR IDirectDrawSurface4, :LPDDSCAPS2
	STDMETHOD	GetClipper, 			:PTR IDirectDrawSurface4, :PTR LPDIRECTDRAWCLIPPER
	STDMETHOD	GetColorKey, 			:PTR IDirectDrawSurface4, :DWORD, :LPDDCOLORKEY
	STDMETHOD	GetDC, 					:PTR IDirectDrawSurface4, :PTR HDC
	STDMETHOD	GetFlipStatus, 			:PTR IDirectDrawSurface4, :DWORD
	STDMETHOD	GetOverlayPosition, 	:PTR IDirectDrawSurface4, :LPLONG, :LPLONG
	STDMETHOD	GetPalette, 			:PTR IDirectDrawSurface4, :PTR LPDIRECTDRAWPALETTE
	STDMETHOD	GetPixelFormat, 		:PTR IDirectDrawSurface4, :LPDDPIXELFORMAT
	STDMETHOD	GetSurfaceDesc, 		:PTR IDirectDrawSurface4, :LPDDSURFACEDESC2
	STDMETHOD	Initialize, 			:PTR IDirectDrawSurface4, :LPDIRECTDRAW, :LPDDSURFACEDESC2
	STDMETHOD	IsLost, 				:PTR IDirectDrawSurface4
	STDMETHOD	_Lock, 					:PTR IDirectDrawSurface4, :LPRECT, :LPDDSURFACEDESC2, :DWORD, :HANDLE 
	STDMETHOD	ReleaseDC, 				:PTR IDirectDrawSurface4, :HDC
	STDMETHOD	Restore, 				:PTR IDirectDrawSurface4
	STDMETHOD	SetClipper, 			:PTR IDirectDrawSurface4, :LPDIRECTDRAWCLIPPER
	STDMETHOD	SetColorKey, 			:PTR IDirectDrawSurface4, :DWORD, :LPDDCOLORKEY
	STDMETHOD	SetOverlayPosition, 	:PTR IDirectDrawSurface4, :LONG, :LONG
	STDMETHOD	SetPalette, 			:PTR IDirectDrawSurface4, :LPDIRECTDRAWPALETTE
	STDMETHOD	Unlock, 				:PTR IDirectDrawSurface4, :LPRECT 
	STDMETHOD	UpdateOverlay, 			:PTR IDirectDrawSurface4, :LPRECT, :LPDIRECTDRAWSURFACE4, :LPRECT, :DWORD, :LPDDOVERLAYFX
	STDMETHOD	UpdateOverlayDisplay, 	:PTR IDirectDrawSurface4, :DWORD
	STDMETHOD	UpdateOverlayZOrder, 	:PTR IDirectDrawSurface4, :DWORD, :LPDIRECTDRAWSURFACE4
	; Added in the v2 interface
	STDMETHOD   GetDDInterface,			:PTR IDirectDrawSurface4, :PTR LPVOID
	STDMETHOD   PageLock,				:PTR IDirectDrawSurface4, :DWORD
	STDMETHOD   PageUnlock,				:PTR IDirectDrawSurface4, :DWORD
	; Added in the v3 interface    
	STDMETHOD	SetSurfaceDesc,			:PTR IDirectDrawSurface4, :LPDDSURFACEDESC2, :DWORD
	; Added in the v4 interface
	STDMETHOD	SetPrivateData,			:PTR IDirectDrawSurface4, :REFGUID, :LPVOID, :DWORD, :DWORD
	STDMETHOD	GetPrivateData,			:PTR IDirectDrawSurface4, :REFGUID, :LPVOID, :LPDWORD
	STDMETHOD	FreePrivateData,		:PTR IDirectDrawSurface4, :REFGUID
	STDMETHOD	GetUniquenessValue,		:PTR IDirectDrawSurface4, :LPDWORD
	STDMETHOD	ChangeUniquenessValue,	:PTR IDirectDrawSurface4
IDirectDrawSurface4Vtbl ENDS

IDirectDrawSurface4 STRUCT
	lpVtbl DWORD ?
IDirectDrawSurface4 ENDS

; ##########################################
; IDirectDrawSurface7 and related interfaces
; ##########################################

IDirectDrawSurface7Vtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDrawSurface7, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDrawSurface7
	STDMETHOD	Release,			 	:PTR IDirectDrawSurface7
	; IDirectDrawSurface7 methods
	STDMETHOD	AddAttachedSurface, 	:PTR IDirectDrawSurface7, :LPDIRECTDRAWSURFACE7
	STDMETHOD	AddOverlayDirtyRect, 	:PTR IDirectDrawSurface7, :LPRECT
	STDMETHOD	Blt, 					:PTR IDirectDrawSurface7, :LPRECT, :LPDIRECTDRAWSURFACE7, :LPRECT, :DWORD, :LPDDBLTFX
	STDMETHOD	BltBatch, 				:PTR IDirectDrawSurface7, :LPDDBLTBATCH, :DWORD, :DWORD
	STDMETHOD	BltFast, 				:PTR IDirectDrawSurface7, :DWORD, :DWORD, :LPDIRECTDRAWSURFACE7, :LPRECT, :DWORD
	STDMETHOD	DeleteAttachedSurface, 	:PTR IDirectDrawSurface7, :DWORD, :LPDIRECTDRAWSURFACE7
	STDMETHOD	EnumAttachedSurfaces, 	:PTR IDirectDrawSurface7, :LPVOID, :LPDDENUMSURFACESCALLBACK7
	STDMETHOD	EnumOverlayZOrders, 	:PTR IDirectDrawSurface7, :DWORD, :LPVOID, :LPDDENUMSURFACESCALLBACK7
	STDMETHOD	Flip, 					:PTR IDirectDrawSurface7, :LPDIRECTDRAWSURFACE7, :DWORD
	STDMETHOD	GetAttachedSurface, 	:PTR IDirectDrawSurface7, :LPDDSCAPS2, :PTR LPDIRECTDRAWSURFACE7
	STDMETHOD	GetBltStatus,	 		:PTR IDirectDrawSurface7, :DWORD
	STDMETHOD	GetCaps, 				:PTR IDirectDrawSurface7, :LPDDSCAPS2
	STDMETHOD	GetClipper, 			:PTR IDirectDrawSurface7, :PTR LPDIRECTDRAWCLIPPER
	STDMETHOD	GetColorKey, 			:PTR IDirectDrawSurface7, :DWORD, :LPDDCOLORKEY
	STDMETHOD	GetDC, 					:PTR IDirectDrawSurface7, :PTR HDC
	STDMETHOD	GetFlipStatus, 			:PTR IDirectDrawSurface7, :DWORD
	STDMETHOD	GetOverlayPosition, 	:PTR IDirectDrawSurface7, :LPLONG, :LPLONG
	STDMETHOD	GetPalette, 			:PTR IDirectDrawSurface7, :PTR LPDIRECTDRAWPALETTE
	STDMETHOD	GetPixelFormat, 		:PTR IDirectDrawSurface7, :LPDDPIXELFORMAT
	STDMETHOD	GetSurfaceDesc, 		:PTR IDirectDrawSurface7, :LPDDSURFACEDESC2
	STDMETHOD	Initialize, 			:PTR IDirectDrawSurface7, :LPDIRECTDRAW, :LPDDSURFACEDESC2
	STDMETHOD	IsLost, 				:PTR IDirectDrawSurface7
	STDMETHOD	_Lock, 					:PTR IDirectDrawSurface7, :LPRECT, :LPDDSURFACEDESC2, :DWORD, :HANDLE 
	STDMETHOD	ReleaseDC, 				:PTR IDirectDrawSurface7, :HDC
	STDMETHOD	Restore, 				:PTR IDirectDrawSurface7
	STDMETHOD	SetClipper, 			:PTR IDirectDrawSurface7, :LPDIRECTDRAWCLIPPER
	STDMETHOD	SetColorKey, 			:PTR IDirectDrawSurface7, :DWORD, :LPDDCOLORKEY
	STDMETHOD	SetOverlayPosition, 	:PTR IDirectDrawSurface7, :LONG, :LONG
	STDMETHOD	SetPalette, 			:PTR IDirectDrawSurface7, :LPDIRECTDRAWPALETTE
	STDMETHOD	Unlock, 				:PTR IDirectDrawSurface7, :LPRECT 
	STDMETHOD	UpdateOverlay, 			:PTR IDirectDrawSurface7, :LPRECT, :LPDIRECTDRAWSURFACE7, :LPRECT, :DWORD, :LPDDOVERLAYFX
	STDMETHOD	UpdateOverlayDisplay, 	:PTR IDirectDrawSurface7, :DWORD
	STDMETHOD	UpdateOverlayZOrder, 	:PTR IDirectDrawSurface7, :DWORD, :LPDIRECTDRAWSURFACE7
    ; Added in the v2 interface
	STDMETHOD   GetDDInterface,			:PTR IDirectDrawSurface7, :PTR LPVOID
	STDMETHOD   PageLock,				:PTR IDirectDrawSurface7, :DWORD
	STDMETHOD   PageUnlock,				:PTR IDirectDrawSurface7, :DWORD    
    ; Added in the v3 interface
	STDMETHOD	SetSurfaceDesc,			:PTR IDirectDrawSurface7, :LPDDSURFACEDESC2, :DWORD
    ; Added in the v4 interface
	STDMETHOD	SetPrivateData,			:PTR IDirectDrawSurface7, :REFGUID, :LPVOID, :DWORD, :DWORD
	STDMETHOD	GetPrivateData,			:PTR IDirectDrawSurface7, :REFGUID, :LPVOID, :LPDWORD
	STDMETHOD	FreePrivateData,		:PTR IDirectDrawSurface7, :REFGUID
	STDMETHOD	GetUniquenessValue,		:PTR IDirectDrawSurface7, :LPDWORD
	STDMETHOD	ChangeUniquenessValue,	:PTR IDirectDrawSurface7
    ; Moved Texture7 methods here
	STDMETHOD	SetPriority,			:PTR IDirectDrawSurface7, :DWORD
	STDMETHOD	GetPriority,			:PTR IDirectDrawSurface7, :LPDWORD
	STDMETHOD	SetLOD,					:PTR IDirectDrawSurface7, :DWORD
	STDMETHOD	GetLOD,					:PTR IDirectDrawSurface7, :LPDWORD
IDirectDrawSurface7Vtbl ENDS

IDirectDrawSurface7 STRUCT
	lpVtbl DWORD ?
IDirectDrawSurface7 ENDS

; #######################
; IDirectDrawColorControl
; #######################

IDirectDrawColorControlVtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDrawColorControl, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDrawColorControl
	STDMETHOD	Release, 				:PTR IDirectDrawColorControl
	; IDirectDrawColorControl methods
	STDMETHOD	GetColorControls,		:PTR IDirectDrawColorControl, :LPDDCOLORCONTROL
	STDMETHOD	SetColorControls,		:PTR IDirectDrawColorControl, :LPDDCOLORCONTROL
IDirectDrawColorControlVtbl ENDS

IDirectDrawColorControl STRUCT
	lpVtbl DWORD ?
IDirectDrawColorControl ENDS

; #######################
; IDirectDrawGammaControl
; #######################

IDirectDrawGammaControlVtbl STRUCT
	; IUnknown methods
	STDMETHOD	QueryInterface, 		:PTR IDirectDrawGammaControl, :REFIID, :PTR LPVOID
	STDMETHOD	AddRef, 				:PTR IDirectDrawGammaControl
	STDMETHOD	Release, 				:PTR IDirectDrawGammaControl
	; IDirectDrawGammaControl methods
	STDMETHOD	GetGammaRamp, 			:PTR IDirectDrawGammaControl, :DWORD, :LPDDGAMMARAMP
	STDMETHOD	SetGammaRamp, 			:PTR IDirectDrawGammaControl, :DWORD, :LPDDGAMMARAMP
IDirectDrawGammaControlVtbl ENDS

IDirectDrawGammaControl STRUCT
	lpVtbl DWORD ?
IDirectDrawGammaControl ENDS

;#############
;DDSURFACEDESC
;#############

DDSURFACEDESC STRUCT
	dwSize							DWORD ?							; size of the DDSURFACEDESC structure
	dwFlags							DWORD ?							; determines what fields are valid
	dwHeight						DWORD ?							; height of surface to be created
	dwWidth							DWORD ?							; width of input surface
	UNION
		lPitch						LONG ?							; distance to start of next line (return value only)
		dwLinearSize				DWORD ?							; Formless late-allocated optimized surface size
	ENDS
	dwBackBufferCount				DWORD ?							; number of back buffers requested
	UNION
		dwMipMapCount				DWORD ?							; number of mip-map levels requested
		dwZBufferBitDepth			DWORD ?							; depth of Z buffer requested
		dwRefreshRate				DWORD ?							; refresh rate (used when display mode is described)
	ENDS
	dwAlphaBitDepth					DWORD ?							; depth of alpha buffer requested
	dwReserved						DWORD ?							; reserved
	lpSurface						LPVOID ?						; pointer to the associated surface memory
	ddckCKDestOverlay				DDCOLORKEY <>					; color key for destination overlay use
	ddckCKDestBlt					DDCOLORKEY <>					; color key for destination blt use
	ddckCKSrcOverlay				DDCOLORKEY <>					; color key for source overlay use
	ddckCKSrcBlt					DDCOLORKEY <>					; color key for source blt use
	ddpfPixelFormat					DDPIXELFORMAT <>				; pixel format description of the surface
	ddsCaps							DDSCAPS <>						; direct draw surface capabilities
DDSURFACEDESC ENDS

;##############
;DDSURFACEDESC2
;##############

DDSURFACEDESC2 STRUCT
	dwSize							DWORD ?							; size of the DDSURFACEDESC structure
	dwFlags							DWORD ?							; determines what fields are valid
	dwHeight						DWORD ?							; height of surface to be created
	dwWidth							DWORD ?							; width of input surface
	UNION
		lPitch						LONG ?							; distance to start of next line (return value only)
		dwLinearSize				DWORD ?							; Formless late-allocated optimized surface size
	ENDS
	UNION
        dwBackBufferCount			DWORD ?							; number of back buffers requested
        dwDepth						DWORD ?							; the depth if this is a volume texture 
	ENDS
	UNION
		dwMipMapCount				DWORD ?							; number of mip-map levels requestde
																	; dwZBufferBitDepth removed, use ddpfPixelFormat one instead
		dwRefreshRate				DWORD ?							; refresh rate (used when display mode is described)
		dwSrcVBHandle				DWORD ?							; The source used in VB::Optimize
	ENDS
	dwAlphaBitDepth					DWORD ?							; depth of alpha buffer requested
	dwReserved						DWORD ?							; reserved
	lpSurface						LPVOID ?						; pointer to the associated surface memory
	UNION
		ddckCKDestOverlay			DDCOLORKEY <>					; color key for destination overlay use
		dwEmptyFaceColor			DWORD ?							; Physical color for empty cubemap faces
	ENDS
	ddckCKDestBlt					DDCOLORKEY <>					; color key for destination blt use
	ddckCKSrcOverlay				DDCOLORKEY <>					; color key for source overlay use
	ddckCKSrcBlt					DDCOLORKEY <>					; color key for source blt use
	UNION
		ddpfPixelFormat				DDPIXELFORMAT <>				; pixel format description of the surface
		dwFVF						DWORD ?							; vertex format description of vertex buffers
	ENDS
	ddsCaps							DDSCAPS2 <>						; direct draw surface capabilities
	dwTextureStage					DWORD ?							; stage in multitexture cascade
DDSURFACEDESC2 ENDS

; #######################
; Flags for DDSURFACEDESC
; #######################

; ddsCaps field is valid. (default)
DDSD_CAPS								EQU 00000001h

; dwHeight field is valid.
DDSD_HEIGHT								EQU 00000002h

; dwWidth field is valid.
DDSD_WIDTH								EQU 00000004h

; lPitch is valid.
DDSD_PITCH								EQU 00000008h

; dwBackBufferCount is valid.
DDSD_BACKBUFFERCOUNT					EQU 00000020h

; dwZBufferBitDepth is valid.  (shouldnt be used in DDSURFACEDESC2)
DDSD_ZBUFFERBITDEPTH					EQU 00000040h

; dwAlphaBitDepth is valid.
DDSD_ALPHABITDEPTH						EQU 00000080h

; lpSurface is valid.
DDSD_LPSURFACE							EQU 00000800h

; ddpfPixelFormat is valid.
DDSD_PIXELFORMAT						EQU 00001000h

; ddckCKDestOverlay is valid.
DDSD_CKDESTOVERLAY						EQU 00002000h

; ddckCKDestBlt is valid.
DDSD_CKDESTBLT							EQU 00004000h

; ddckCKSrcOverlay is valid.
DDSD_CKSRCOVERLAY						EQU 00008000h

; ddckCKSrcBlt is valid.
DDSD_CKSRCBLT							EQU 00010000h

; dwMipMapCount is valid.
DDSD_MIPMAPCOUNT						EQU 00020000h

; dwRefreshRate is valid
DDSD_REFRESHRATE						EQU 00040000h

; dwLinearSize is valid
DDSD_LINEARSIZE							EQU 00080000h

; dwTextureStage is valid
DDSD_TEXTURESTAGE						EQU 00100000h

; dwFVF is valid
DDSD_FVF								EQU 00200000h

; dwSrcVBHandle is valid
DDSD_SRCVBHANDLE						EQU 00400000h

; dwDepth is valid
DDSD_DEPTH								EQU 00800000h

; All input fields are valid.
DDSD_ALL								EQU 00fff9eeh

; ################
; DDOPTSURFACEDESC
; ################

DDOPTSURFACEDESC STRUCT
	dwSize								DWORD ?						; size of the DDOPTSURFACEDESC structure
	dwFlags								DWORD ?						; determines what fields are valid
	ddSCaps								DDSCAPS2 <>					; Common caps like: Memory type
	ddOSCaps							DDOSCAPS <>					; Common caps like: Memory type
	guid								GUID <>						; Compression technique GUID
	dwCompressionRatio					DWORD ?						; Compression ratio
DDOPTSURFACEDESC ENDS

; guid field is valid.
DDOSD_GUID								EQU 00000001h

; dwCompressionRatio field is valid.
DDOSD_COMPRESSION_RATIO					EQU 00000002h

; ddSCaps field is valid.
DDOSD_SCAPS								EQU 00000004h

; ddOSCaps field is valid.
DDOSD_OSCAPS							EQU 00000008h

; All input fields are valid.
DDOSD_ALL								EQU 0000000fh

; The surface's optimized pixelformat is compressed
DDOSDCAPS_OPTCOMPRESSED					EQU 00000001h

; The surface's optimized pixelformat is reordered
DDOSDCAPS_OPTREORDERED					EQU 00000002h

; The opt surface is a monolithic mipmap
DDOSDCAPS_MONOLITHICMIPMAP				EQU 00000004h

; The valid Surf caps:
;   DDSCAPS_SYSTEMMEMORY				EQU 00000800h
;   DDSCAPS_VIDEOMEMORY					EQU 00004000h
;   DDSCAPS_LOCALVIDMEM					EQU 10000000h
;   DDSCAPS_NONLOCALVIDMEM				EQU 20000000h
DDOSDCAPS_VALIDSCAPS					EQU 30004800h

; The valid OptSurf caps
DDOSDCAPS_VALIDOSCAPS					EQU 00000007h

; ##############
; DDCOLORCONTROL
; ##############

DDCOLORCONTROL STRUCT
	dwSize								DWORD ?
	dwFlags								DWORD ?
	lBrightness							LONG ?
	lContrast							LONG ?
	lHue								LONG ?
	lSaturation							LONG ?
	lSharpness							LONG ?
	lGamma								LONG ?
	lColorEnable						LONG ?
	dwReserved1 						DWORD ?
DDCOLORCONTROL ENDS

; lBrightness field is valid.
DDCOLOR_BRIGHTNESS						EQU 00000001h

; lContrast field is valid.
DDCOLOR_CONTRAST						EQU 00000002h

; lHue field is valid.
DDCOLOR_HUE								EQU 00000004h

; lSaturation field is valid.
DDCOLOR_SATURATION						EQU 00000008h

; lSharpness field is valid.
DDCOLOR_SHARPNESS						EQU 00000010h

; lGamma field is valid.
DDCOLOR_GAMMA							EQU 00000020h

; lColorEnable field is valid.
DDCOLOR_COLORENABLE						EQU 00000040h

; #####################################################################
; #####################################################################
;
; Direct Draw Capability Flags
;
; These flags are used to describe the capabilities of a given Surface.
; All flags are bit flags.
;
; #####################################################################
; #####################################################################

; ##################################
; DIRECTDRAWSURFACE CAPABILITY FLAGS
; ##################################

; This bit is reserved. It should not be specified.
DDSCAPS_RESERVED1						EQU 00000001h

; Indicates that this surface contains alpha-only information.
; (To determine if a surface is RGBA/YUVA, the pixel format must be
; interrogated.)
DDSCAPS_ALPHA							EQU 00000002h

; Indicates that this surface is a backbuffer.	It is generally
; set by CreateSurface when the DDSCAPS_FLIP capability bit is set.
; It indicates that this surface is THE back buffer of a surface
; flipping structure.  DirectDraw supports N surfaces in a
; surface flipping structure.  Only the surface that immediately
; precedeces the DDSCAPS_FRONTBUFFER has this capability bit set.
; The other surfaces are identified as back buffers by the presence
; of the DDSCAPS_FLIP capability, their attachment order, and the
; absence of the DDSCAPS_FRONTBUFFER and DDSCAPS_BACKBUFFER
; capabilities.  The bit is sent to CreateSurface when a standalone
; back buffer is being created.  This surface could be attached to
; a front buffer and/or back buffers to form a flipping surface
; structure after the CreateSurface call.  See AddAttachments for
; a detailed description of the behaviors in this case.
DDSCAPS_BACKBUFFER						EQU 00000004h

; Indicates a complex surface structure is being described.  A
; complex surface structure results in the creation of more than
; one surface.	The additional surfaces are attached to the root
; surface.	The complex structure can only be destroyed by
; destroying the root.
DDSCAPS_COMPLEX							EQU 00000008h

; Indicates that this surface is a part of a surface flipping structure.
; When it is passed to CreateSurface the DDSCAPS_FRONTBUFFER and
; DDSCAP_BACKBUFFER bits are not set.  They are set by CreateSurface
; on the resulting creations.  The dwBackBufferCount field in the
; DDSURFACEDESC structure must be set to at least 1 in order for
; the CreateSurface call to succeed.  The DDSCAPS_COMPLEX capability
; must always be set with creating multiple surfaces through CreateSurface.
DDSCAPS_FLIP							EQU 00000010h

; Indicates that this surface is THE front buffer of a surface flipping
; structure.  It is generally set by CreateSurface when the DDSCAPS_FLIP
; capability bit is set.
; If this capability is sent to CreateSurface then a standalonw front buffer
; is created.  This surface will not have the DDSCAPS_FLIP capability.
; It can be attached to other back buffers to form a flipping structure.
; See AddAttachments for a detailed description of the behaviors in this
; case.
DDSCAPS_FRONTBUFFER						EQU 00000020h

; Indicates that this surface is any offscreen surface that is not an overlay,
; texture, zbuffer, front buffer, back buffer, or alpha surface.  It is used
; to identify plain vanilla surfaces.
DDSCAPS_OFFSCREENPLAIN					EQU 00000040h

; Indicates that this surface is an overlay.  It may or may not be directly visible
; depending on whether or not it is currently being overlayed onto the primary
; surface.	DDSCAPS_VISIBLE can be used to determine whether or not it is being
; overlayed at the moment.
DDSCAPS_OVERLAY							EQU 00000080h

; Indicates that unique DirectDrawPalette objects can be created and
; attached to this surface.
DDSCAPS_PALETTE							EQU 00000100h

; Indicates that this surface is the primary surface.  The primary
; surface represents what the user is seeing at the moment.
DDSCAPS_PRIMARYSURFACE					EQU 00000200h

; This flag used to be DDSCAPS_PRIMARYSURFACELEFT, which is now
; obsolete.
DDSCAPS_RESERVED3						EQU 00000400h
DDSCAPS_PRIMARYSURFACELEFT				EQU 00000000h

; Indicates that this surface memory was allocated in system memory
DDSCAPS_SYSTEMMEMORY					EQU 00000800h

; Indicates that this surface can be used as a 3D texture.	It does not
; indicate whether or not the surface is being used for that purpose.
DDSCAPS_TEXTURE							EQU 00001000h

; Indicates that a surface may be a destination for 3D rendering.  This
; bit must be set in order to query for a Direct3D Device Interface
; from this surface.
DDSCAPS_3DDEVICE						EQU 00002000h

; Indicates that this surface exists in video memory.
DDSCAPS_VIDEOMEMORY						EQU 00004000h

; Indicates that changes made to this surface are immediately visible.
; It is always set for the primary surface and is set for overlays while
; they are being overlayed and texture maps while they are being textured.
DDSCAPS_VISIBLE							EQU 00008000h

; Indicates that only writes are permitted to the surface.	Read accesses
; from the surface may or may not generate a protection fault, but the
; results of a read from this surface will not be meaningful.  READ ONLY.
DDSCAPS_WRITEONLY						EQU 00010000h

; Indicates that this surface is a z buffer. A z buffer does not contain
; displayable information.	Instead it contains bit depth information that is
; used to determine which pixels are visible and which are obscured.
DDSCAPS_ZBUFFER							EQU 00020000h

; Indicates surface will have a DC associated long term
DDSCAPS_OWNDC							EQU 00040000h

; Indicates surface should be able to receive live video
DDSCAPS_LIVEVIDEO						EQU 00080000h

; Indicates surface should be able to have a stream decompressed
; to it by the hardware.
DDSCAPS_HWCODEC							EQU 00100000h

; Surface is a ModeX surface.
DDSCAPS_MODEX							EQU 00200000h

; Indicates surface is one level of a mip-map. This surface will
; be attached to other DDSCAPS_MIPMAP surfaces to form the mip-map.
; This can be done explicitly, by creating a number of surfaces and
; attaching them with AddAttachedSurface or by implicitly by CreateSurface.
; If this bit is set then DDSCAPS_TEXTURE must also be set.
DDSCAPS_MIPMAP							EQU 00400000h

; This bit is reserved. It should not be specified.
DDSCAPS_RESERVED2						EQU 00800000h

; Indicates that memory for the surface is not allocated until the surface
; is loaded (via the Direct3D texture Load() function).
DDSCAPS_ALLOCONLOAD						EQU 04000000h

; Indicates that the surface will recieve data from a video port.
DDSCAPS_VIDEOPORT						EQU 08000000h

; Indicates that a video memory surface is resident in true, local video
; memory rather than non-local video memory. If this flag is specified then
; so must DDSCAPS_VIDEOMEMORY. This flag is mutually exclusive with
; DDSCAPS_NONLOCALVIDMEM.
DDSCAPS_LOCALVIDMEM						EQU 10000000h

; Indicates that a video memory surface is resident in non-local video
; memory rather than true, local video memory. If this flag is specified
; then so must DDSCAPS_VIDEOMEMORY. This flag is mutually exclusive with
; DDSCAPS_LOCALVIDMEM.
DDSCAPS_NONLOCALVIDMEM					EQU 20000000h

; Indicates that this surface is a standard VGA mode surface, and not a
; ModeX surface. (This flag will never be set in combination with the
; DDSCAPS_MODEX flag).
DDSCAPS_STANDARDVGAMODE					EQU 40000000h

; Indicates that this surface will be an optimized surface. This flag is
; currently only valid in conjunction with the DDSCAPS_TEXTURE flag. The surface
; will be created without any underlying video memory until loaded.
DDSCAPS_OPTIMIZED						EQU 80000000h

; This bit is reserved
DDSCAPS2_RESERVED4						EQU 00000002h
DDSCAPS2_HARDWAREDEINTERLACE			EQU 00000000h

; Indicates to the driver that this surface will be locked very frequently
; (for procedural textures, dynamic lightmaps, etc). Surfaces with this cap
; set must also have DDSCAPS_TEXTURE. This cap cannot be used with
; DDSCAPS2_HINTSTATIC and DDSCAPS2_OPAQUE.
DDSCAPS2_HINTDYNAMIC					EQU 00000004h

; Indicates to the driver that this surface can be re-ordered/retiled on
; load. This operation will not change the size of the texture. It is
; relatively fast and symmetrical, since the application may lock these
; bits (although it will take a performance hit when doing so). Surfaces
; with this cap set must also have DDSCAPS_TEXTURE. This cap cannot be
; used with DDSCAPS2_HINTDYNAMIC and DDSCAPS2_OPAQUE.
DDSCAPS2_HINTSTATIC						EQU 00000008h

; Indicates that the client would like this texture surface to be managed by the
; DirectDraw/Direct3D runtime. Surfaces with this cap set must also have
; DDSCAPS_TEXTURE set.
DDSCAPS2_TEXTUREMANAGE					EQU 00000010h

; These bits are reserved for internal use;
DDSCAPS2_RESERVED1						EQU 00000020h
DDSCAPS2_RESERVED2						EQU 00000040h

; Indicates to the driver that this surface will never be locked again.
; The driver is free to optimize this surface via retiling and actual compression.
; All calls to Lock() or Blts from this surface will fail. Surfaces with this
; cap set must also have DDSCAPS_TEXTURE. This cap cannot be used with
; DDSCAPS2_HINTDYNAMIC and DDSCAPS2_HINTSTATIC.
DDSCAPS2_OPAQUE							EQU 00000080h

; Applications should set this bit at CreateSurface time to indicate that they
; intend to use antialiasing. Only valid if DDSCAPS_3DDEVICE is also set.
DDSCAPS2_HINTANTIALIASING				EQU 00000100h

; This flag is used at CreateSurface time to indicate that this set of
; surfaces is a cubic environment map
DDSCAPS2_CUBEMAP						EQU 00000200h

; These flags preform two functions:
; - At CreateSurface time, they define which of the six cube faces are
;	required by the application.
; - After creation, each face in the cubemap will have exactly one of these
;	bits set.
DDSCAPS2_CUBEMAP_POSITIVEX				EQU 00000400h
DDSCAPS2_CUBEMAP_NEGATIVEX				EQU 00000800h
DDSCAPS2_CUBEMAP_POSITIVEY				EQU 00001000h
DDSCAPS2_CUBEMAP_NEGATIVEY				EQU 00002000h
DDSCAPS2_CUBEMAP_POSITIVEZ				EQU 00004000h
DDSCAPS2_CUBEMAP_NEGATIVEZ				EQU 00008000h

; This macro may be used to specify all faces of a cube map at CreateSurface time
DDSCAPS2_CUBEMAP_ALLFACES 				EQU (DDSCAPS2_CUBEMAP_POSITIVEX OR DDSCAPS2_CUBEMAP_NEGATIVEX OR DDSCAPS2_CUBEMAP_POSITIVEY OR DDSCAPS2_CUBEMAP_NEGATIVEY OR DDSCAPS2_CUBEMAP_POSITIVEZ OR DSCAPS2_CUBEMAP_NEGATIVEZ)

; This flag is an additional flag which is present on mipmap sublevels from DX7 onwards
; It enables easier use of GetAttachedSurface rather than EnumAttachedSurfaces for surface
; constructs such as Cube Maps, wherein there are more than one mipmap surface attached
; to the root surface.
; This caps bit is ignored by CreateSurface
DDSCAPS2_MIPMAPSUBLEVEL					EQU 00010000h

; This flag indicates that the texture should be managed by D3D only;
DDSCAPS2_D3DTEXTUREMANAGE				EQU 00020000h

; This flag indicates that the managed surface can be safely lost;
DDSCAPS2_DONOTPERSIST					EQU 00040000h

; indicates that this surface is part of a stereo flipping chain;
DDSCAPS2_STEREOSURFACELEFT				EQU 00080000h

; Indicates that the surface is a volume.
; Can be combined with DDSCAPS_MIPMAP to indicate a multi-level volume
DDSCAPS2_VOLUME							EQU 00200000h

; Indicates that the surface may be locked multiple times by the application.
; This cap cannot be used with DDSCAPS2_OPAQUE.
DDSCAPS2_NOTUSERLOCKABLE				EQU 00400000h

; Indicates that the vertex buffer data can be used to render points and
; point sprites.
DDSCAPS2_POINTS							EQU 00800000h

; Indicates that the vertex buffer data can be used to render rt pactches.
DDSCAPS2_RTPATCHES						EQU 01000000h

; Indicates that the vertex buffer data can be used to render n patches.
DDSCAPS2_NPATCHES						EQU 02000000h

; This bit is reserved for internal use 
DDSCAPS2_RESERVED3						EQU 04000000h

; Indicates that the contents of the backbuffer do not have to be preserved
; the contents of the backbuffer after they are presented.
DDSCAPS2_DISCARDBACKBUFFER				EQU 10000000h

; Indicates that all surfaces in this creation chain should be given an alpha channel.
; This flag will be set on primary surface chains that may have no explicit pixel format
; (and thus take on the format of the current display mode).
; The driver should infer that all these surfaces have a format having an alpha channel.
; (e.g. assume D3DFMT_A8R8G8B8 if the display mode is x888.)
DDSCAPS2_ENABLEALPHACHANNEL				EQU 20000000h

; Indicates that all surfaces in this creation chain is extended primary surface format.
; This flag will be set on extended primary surface chains that always have explicit pixel
; format and the pixel format is typically GDI (Graphics Device Interface) couldn't handle,
; thus only used with fullscreen application. (e.g. D3DFMT_A2R10G10B10 format)
DDSCAPS2_EXTENDEDFORMATPRIMARY			EQU 40000000h

; Indicates that all surfaces in this creation chain is additional primary surface.
; This flag will be set on primary surface chains which must present on the adapter
; id provided on dwCaps4. Typically this will be used to create secondary primary surface
; on DualView display adapter.
DDSCAPS2_ADDITIONALPRIMARY				EQU 80000000h

; This is a mask that indicates the set of bits that may be set
; at createsurface time to indicate number of samples per pixel
; when multisampling
DDSCAPS3_MULTISAMPLE_MASK				EQU 0000001Fh

; This is a mask that indicates the set of bits that may be set
; at createsurface time to indicate the quality level of rendering
; for the current number of samples per pixel
DDSCAPS3_MULTISAMPLE_QUALITY_MASK		EQU 000000E0h
DDSCAPS3_MULTISAMPLE_QUALITY_SHIFT		EQU 5

; This bit is reserved for internal use 
DDSCAPS3_RESERVED1						EQU 00000100h

; This bit is reserved for internal use 
DDSCAPS3_RESERVED2						EQU 00000200h

; This indicates whether this surface has light-weight miplevels
DDSCAPS3_LIGHTWEIGHTMIPMAP				EQU 00000400h

; This indicates that the mipsublevels for this surface are auto-generated
DDSCAPS3_AUTOGENMIPMAP					EQU 00000800h

; This indicates that the mipsublevels for this surface are auto-generated
DDSCAPS3_DMAP							EQU 00001000h

; ##################################
; DIRECTDRAW DRIVER CAPABILITY FLAGS
; ##################################

; Display hardware has 3D acceleration.
DDCAPS_3D								EQU 00000001h

; Indicates that DirectDraw will support only dest rectangles that are aligned
; on DIRECTDRAWCAPS.dwAlignBoundaryDest boundaries of the surface, respectively.
; READ ONLY.
DDCAPS_ALIGNBOUNDARYDEST				EQU 00000002h

; Indicates that DirectDraw will support only source rectangles  whose sizes in
; BYTEs are DIRECTDRAWCAPS.dwAlignSizeDest multiples, respectively.  READ ONLY.
DDCAPS_ALIGNSIZEDEST					EQU 00000004h
;
; Indicates that DirectDraw will support only source rectangles that are aligned
; on DIRECTDRAWCAPS.dwAlignBoundarySrc boundaries of the surface, respectively.
; READ ONLY.
DDCAPS_ALIGNBOUNDARYSRC					EQU 00000008h

; Indicates that DirectDraw will support only source rectangles  whose sizes in
; BYTEs are DIRECTDRAWCAPS.dwAlignSizeSrc multiples, respectively.	READ ONLY.
DDCAPS_ALIGNSIZESRC						EQU 00000010h

; Indicates that DirectDraw will create video memory surfaces that have a stride
; alignment equal to DIRECTDRAWCAPS.dwAlignStride.	READ ONLY.
DDCAPS_ALIGNSTRIDE						EQU 00000020h

; Display hardware is capable of blt operations.
DDCAPS_BLT								EQU 00000040h

; Display hardware is capable of asynchronous blt operations.
DDCAPS_BLTQUEUE							EQU 00000080h

; Display hardware is capable of color space conversions during the blt operation.
DDCAPS_BLTFOURCC						EQU 00000100h

; Display hardware is capable of stretching during blt operations.
DDCAPS_BLTSTRETCH						EQU 00000200h

; Display hardware is shared with GDI.
DDCAPS_GDI								EQU 00000400h

; Display hardware can overlay.
DDCAPS_OVERLAY							EQU 00000800h

; Set if display hardware supports overlays but can not clip them.
DDCAPS_OVERLAYCANTCLIP					EQU 00001000h

; Indicates that overlay hardware is capable of color space conversions during
; the overlay operation.
DDCAPS_OVERLAYFOURCC					EQU 00002000h

; Indicates that stretching can be done by the overlay hardware.
DDCAPS_OVERLAYSTRETCH					EQU 00004000h

; Indicates that unique DirectDrawPalettes can be created for DirectDrawSurfaces
; other than the primary surface.
DDCAPS_PALETTE							EQU 00008000h

; Indicates that palette changes can be syncd with the veritcal refresh.
DDCAPS_PALETTEVSYNC						EQU 00010000h

; Display hardware can return the current scan line.
DDCAPS_READSCANLINE						EQU 00020000h

; This flag used to bo DDCAPS_STEREOVIEW, which is now obsolete
DDCAPS_RESERVED1						EQU 00040000h

; Display hardware is capable of generating a vertical blank interrupt.
DDCAPS_VBI								EQU 00080000h

; Supports the use of z buffers with blt operations.
DDCAPS_ZBLTS							EQU 00100000h

; Supports Z Ordering of overlays.
DDCAPS_ZOVERLAYS						EQU 00200000h

; Supports color key
DDCAPS_COLORKEY							EQU 00400000h

; Supports alpha surfaces
DDCAPS_ALPHA							EQU 00800000h

; colorkey is hardware assisted(DDCAPS_COLORKEY will also be set)
DDCAPS_COLORKEYHWASSIST					EQU 01000000h

; no hardware support at all
DDCAPS_NOHARDWARE						EQU 02000000h

; Display hardware is capable of color fill with bltter
DDCAPS_BLTCOLORFILL						EQU 04000000h

; Display hardware is bank switched, and potentially very slow at
; random access to VRAM.
DDCAPS_BANKSWITCHED						EQU 08000000h

; Display hardware is capable of depth filling Z-buffers with bltter
DDCAPS_BLTDEPTHFILL						EQU 10000000h

; Display hardware is capable of clipping while bltting.
DDCAPS_CANCLIP							EQU 20000000h

; Display hardware is capable of clipping while stretch bltting.
DDCAPS_CANCLIPSTRETCHED					EQU 40000000h

; Display hardware is capable of bltting to or from system memory
DDCAPS_CANBLTSYSMEM						EQU 80000000h

; #################################################
; MORE DIRECTDRAW DRIVER CAPABILITY FLAGS (dwCaps2)
; #################################################

; Display hardware is certified
DDCAPS2_CERTIFIED			   			EQU 00000001h

; Driver cannot interleave 2D operations (lock and blt) to surfaces with
; Direct3D rendering operations between calls to BeginScene() and EndScene()
DDCAPS2_NO2DDURING3DSCENE				EQU 00000002h

; Display hardware contains a video port
DDCAPS2_VIDEOPORT						EQU 00000004h

; The overlay can be automatically flipped according to the video port
; VSYNCs, providing automatic doubled buffered display of video port
; data using an overlay
DDCAPS2_AUTOFLIPOVERLAY					EQU 00000008h

; Overlay can display each field of interlaced data individually while
; it is interleaved in memory without causing jittery artifacts.
DDCAPS2_CANBOBINTERLEAVED				EQU 00000010h

; Overlay can display each field of interlaced data individually while
; it is not interleaved in memory without causing jittery artifacts.
DDCAPS2_CANBOBNONINTERLEAVED			EQU 00000020h

; The overlay surface contains color controls (brightness, sharpness, etc.)
DDCAPS2_COLORCONTROLOVERLAY				EQU 00000040h

; The primary surface contains color controls (gamma, etc.)
DDCAPS2_COLORCONTROLPRIMARY				EQU 00000080h

; RGBZ -> RGB supported for 16:16 RGB:Z
DDCAPS2_CANDROPZ16BIT					EQU 00000100h

; Driver supports non-local video memory.
DDCAPS2_NONLOCALVIDMEM					EQU 00000200h

; Dirver supports non-local video memory but has different capabilities for
; non-local video memory surfaces. If this bit is set then so must
; DDCAPS2_NONLOCALVIDMEM.
DDCAPS2_NONLOCALVIDMEMCAPS				EQU 00000400h

; Driver neither requires nor prefers surfaces to be pagelocked when performing
; blts involving system memory surfaces
DDCAPS2_NOPAGELOCKREQUIRED				EQU 00000800h

; Driver can create surfaces which are wider than the primary surface
DDCAPS2_WIDESURFACES					EQU 00001000h

; Driver supports bob without using a video port by handling the
; DDFLIP_ODD and DDFLIP_EVEN flags specified in Flip.
DDCAPS2_CANFLIPODDEVEN					EQU 00002000h

; Driver supports bob using hardware
DDCAPS2_CANBOBHARDWARE					EQU 00004000h

; Driver supports bltting any FOURCC surface to another surface of the same FOURCC
DDCAPS2_COPYFOURCC						EQU 00008000h

; Driver supports loadable gamma ramps for the primary surface
DDCAPS2_PRIMARYGAMMA					EQU 00020000h

; Driver can render in windowed mode.
DDCAPS2_CANRENDERWINDOWED				EQU 00080000h

; A calibrator is available to adjust the gamma ramp according to the
; physical display properties so that the result will be identical on
; all calibrated systems.
DDCAPS2_CANCALIBRATEGAMMA				EQU 00100000h

; Indicates that the driver will respond to DDFLIP_INTERVALn flags
DDCAPS2_FLIPINTERVAL					EQU 00200000h

; Indicates that the driver will respond to DDFLIP_NOVSYNC
DDCAPS2_FLIPNOVSYNC						EQU 00400000h

; Driver supports management of video memory, if this flag is ON,
; driver manages the texture if requested with DDSCAPS2_TEXTUREMANAGE on
; DirectX manages the texture if this flag is OFF and surface has DDSCAPS2_TEXTUREMANAGE on
DDCAPS2_CANMANAGETEXTURE				EQU 00800000h

; The Direct3D texture manager uses this cap to decide whether to put managed
; surfaces in non-local video memory. If the cap is set, the texture manager will
; put managed surfaces in non-local vidmem. Drivers that cannot texture from
; local vidmem SHOULD NOT set this cap.
DDCAPS2_TEXMANINNONLOCALVIDMEM			EQU 01000000h

; Indicates that the driver supports DX7 type of stereo in at least one mode (which may
; not necessarily be the current mode). Applications should use IDirectDraw7 (or higher)
; ::EnumDisplayModes and check the DDSURFACEDESC.ddsCaps.dwCaps2 field for the presence of
; DDSCAPS2_STEREOSURFACELEFT to check if a particular mode supports stereo. The application
; can also use IDirectDraw7(or higher)::GetDisplayMode to check the current mode.
DDCAPS2_STEREO							EQU 02000000h

; This caps bit is intended for internal DirectDraw use.
; -It is only valid if DDCAPS2_NONLOCALVIDMEMCAPS is set.
; -If this bit is set, then DDCAPS_CANBLTSYSMEM MUST be set by the driver (and
;  all the assoicated system memory blt caps must be correct).
; -It implies that the system->video blt caps in DDCAPS also apply to system to
;  nonlocal blts. I.e. the dwSVBCaps, dwSVBCKeyCaps, dwSVBFXCaps and dwSVBRops
;  members of DDCAPS (DDCORECAPS) are filled in correctly.
; -Any blt from system to nonlocal memory that matches these caps bits will
;  be passed to the driver.
;
; NOTE: This is intended to enable the driver itself to do efficient reordering
; of textures. This is NOT meant to imply that hardware can write into AGP memory.
; This operation is not currently supported.
DDCAPS2_SYSTONONLOCAL_AS_SYSTOLOCAL   	EQU 04000000h

; was DDCAPS2_PUREHAL
DDCAPS2_RESERVED1					  	EQU 08000000h

; Driver supports management of video memory, if this flag is ON,
; driver manages the resource if requested with DDSCAPS2_TEXTUREMANAGE on
; DirectX manages the resource if this flag is OFF and surface has DDSCAPS2_TEXTUREMANAGE on
DDCAPS2_CANMANAGERESOURCE			  	EQU 10000000h

; Driver supports dynamic textures. This will allow the application to set
; D3DUSAGE_DYNAMIC (DDSCAPS2_HINTDYNAMIC for drivers) at texture create time.
; Video memory dynamic textures WILL be lockable by applications. It is
; expected that these locks will be very efficient (which implies that the
; driver should always maintain a linear copy, a pointer to which can be
; quickly handed out to the application).
DDCAPS2_DYNAMICTEXTURES				  	EQU 20000000h

; Driver supports auto-generation of mipmaps.
DDCAPS2_CANAUTOGENMIPMAP			  	EQU 40000000h

; ####################################
; DIRECTDRAW FX ALPHA CAPABILITY FLAGS
; ####################################

; Supports alpha blending around the edge of a source color keyed surface.
; For Blt.
DDFXALPHACAPS_BLTALPHAEDGEBLEND			EQU 00000001h

; Supports alpha information in the pixel format.  The bit depth of alpha
; information in the pixel format can be 1,2,4, or 8.  The alpha value becomes
; more opaque as the alpha value increases.  (0 is transparent.)
; For Blt.
DDFXALPHACAPS_BLTALPHAPIXELS			EQU 00000002h

; Supports alpha information in the pixel format.  The bit depth of alpha
; information in the pixel format can be 1,2,4, or 8.  The alpha value
; becomes more transparent as the alpha value increases.  (0 is opaque.)
; This flag can only be set if DDCAPS_ALPHA is set.
; For Blt.
DDFXALPHACAPS_BLTALPHAPIXELSNEG			EQU 00000004h

; Supports alpha only surfaces.  The bit depth of an alpha only surface can be
; 1,2,4, or 8.	The alpha value becomes more opaque as the alpha value increases.
; (0 is transparent.)
; For Blt.
DDFXALPHACAPS_BLTALPHASURFACES			EQU 00000008h

; The depth of the alpha channel data can range can be 1,2,4, or 8.
; The NEG suffix indicates that this alpha channel becomes more transparent
; as the alpha value increases. (0 is opaque.)	This flag can only be set if
; DDCAPS_ALPHA is set.
; For Blt.
DDFXALPHACAPS_BLTALPHASURFACESNEG		EQU 00000010h

; Supports alpha blending around the edge of a source color keyed surface.
; For Overlays.
DDFXALPHACAPS_OVERLAYALPHAEDGEBLEND		EQU 00000020h

; Supports alpha information in the pixel format.  The bit depth of alpha
; information in the pixel format can be 1,2,4, or 8.  The alpha value becomes
; more opaque as the alpha value increases.  (0 is transparent.)
; For Overlays.
DDFXALPHACAPS_OVERLAYALPHAPIXELS		EQU 00000040h

; Supports alpha information in the pixel format.  The bit depth of alpha
; information in the pixel format can be 1,2,4, or 8.  The alpha value
; becomes more transparent as the alpha value increases.  (0 is opaque.)
; This flag can only be set if DDCAPS_ALPHA is set.
; For Overlays.
DDFXALPHACAPS_OVERLAYALPHAPIXELSNEG		EQU 00000080h

; Supports alpha only surfaces.  The bit depth of an alpha only surface can be
; 1,2,4, or 8.	The alpha value becomes more opaque as the alpha value increases.
; (0 is transparent.)
; For Overlays.
DDFXALPHACAPS_OVERLAYALPHASURFACES		EQU 00000100h

; The depth of the alpha channel data can range can be 1,2,4, or 8.
; The NEG suffix indicates that this alpha channel becomes more transparent
; as the alpha value increases. (0 is opaque.)	This flag can only be set if
; DDCAPS_ALPHA is set.
; For Overlays.
DDFXALPHACAPS_OVERLAYALPHASURFACESNEG	EQU 00000200h

; ##############################
; DIRECTDRAW FX CAPABILITY FLAGS
; ##############################

; Uses arithmetic operations to stretch and shrink surfaces during blt
; rather than pixel doubling techniques.  Along the Y axis.
DDFXCAPS_BLTARITHSTRETCHY				EQU 00000020h

; Uses arithmetic operations to stretch during blt
; rather than pixel doubling techniques.  Along the Y axis. Only
; works for x1, x2, etc.
DDFXCAPS_BLTARITHSTRETCHYN				EQU 00000010h

; Supports mirroring left to right in blt.
DDFXCAPS_BLTMIRRORLEFTRIGHT				EQU 00000040h

; Supports mirroring top to bottom in blt.
DDFXCAPS_BLTMIRRORUPDOWN				EQU 00000080h

; Supports arbitrary rotation for blts.
DDFXCAPS_BLTROTATION					EQU 00000100h

; Supports 90 degree rotations for blts.
DDFXCAPS_BLTROTATION90					EQU 00000200h

; DirectDraw supports arbitrary shrinking of a surface along the
; x axis (horizontal direction) for blts.
DDFXCAPS_BLTSHRINKX						EQU 00000400h

; DirectDraw supports integer shrinking (1x,2x,) of a surface
; along the x axis (horizontal direction) for blts.
DDFXCAPS_BLTSHRINKXN					EQU 00000800h

; DirectDraw supports arbitrary shrinking of a surface along the
; y axis (horizontal direction) for blts.
DDFXCAPS_BLTSHRINKY						EQU 00001000h

; DirectDraw supports integer shrinking (1x,2x,) of a surface
; along the y axis (vertical direction) for blts.
DDFXCAPS_BLTSHRINKYN					EQU 00002000h

; DirectDraw supports arbitrary stretching of a surface along the
; x axis (horizontal direction) for blts.
DDFXCAPS_BLTSTRETCHX					EQU 00004000h

; DirectDraw supports integer stretching (1x,2x,) of a surface
; along the x axis (horizontal direction) for blts.
DDFXCAPS_BLTSTRETCHXN					EQU 00008000h

; DirectDraw supports arbitrary stretching of a surface along the
; y axis (horizontal direction) for blts.
DDFXCAPS_BLTSTRETCHY					EQU 00010000h

; DirectDraw supports integer stretching (1x,2x,) of a surface
; along the y axis (vertical direction) for blts.
DDFXCAPS_BLTSTRETCHYN					EQU 00020000h

; Uses arithmetic operations to stretch and shrink surfaces during
; overlay rather than pixel doubling techniques.  Along the Y axis
; for overlays.
DDFXCAPS_OVERLAYARITHSTRETCHY			EQU 00040000h

; Uses arithmetic operations to stretch surfaces during
; overlay rather than pixel doubling techniques.  Along the Y axis
; for overlays. Only works for x1, x2, etc.
DDFXCAPS_OVERLAYARITHSTRETCHYN			EQU 00000008h

; DirectDraw supports arbitrary shrinking of a surface along the
; x axis (horizontal direction) for overlays.
DDFXCAPS_OVERLAYSHRINKX					EQU 00080000h

; DirectDraw supports integer shrinking (1x,2x,) of a surface
; along the x axis (horizontal direction) for overlays.
DDFXCAPS_OVERLAYSHRINKXN				EQU 00100000h

; DirectDraw supports arbitrary shrinking of a surface along the
; y axis (horizontal direction) for overlays.
DDFXCAPS_OVERLAYSHRINKY					EQU 00200000h

; DirectDraw supports integer shrinking (1x,2x,) of a surface
; along the y axis (vertical direction) for overlays.
DDFXCAPS_OVERLAYSHRINKYN				EQU 00400000h

; DirectDraw supports arbitrary stretching of a surface along the
; x axis (horizontal direction) for overlays.
DDFXCAPS_OVERLAYSTRETCHX				EQU 00800000h

; DirectDraw supports integer stretching (1x,2x,) of a surface
; along the x axis (horizontal direction) for overlays.
DDFXCAPS_OVERLAYSTRETCHXN				EQU 01000000h

; DirectDraw supports arbitrary stretching of a surface along the
; y axis (horizontal direction) for overlays.
DDFXCAPS_OVERLAYSTRETCHY				EQU 02000000h

; DirectDraw supports integer stretching (1x,2x,) of a surface
; along the y axis (vertical direction) for overlays.
DDFXCAPS_OVERLAYSTRETCHYN				EQU 04000000h

; DirectDraw supports mirroring of overlays across the vertical axis
DDFXCAPS_OVERLAYMIRRORLEFTRIGHT 		EQU 08000000h

; DirectDraw supports mirroring of overlays across the horizontal axis
DDFXCAPS_OVERLAYMIRRORUPDOWN			EQU 10000000h

; DirectDraw supports deinterlacing of overlay surfaces
DDFXCAPS_OVERLAYDEINTERLACE				EQU 20000000h

; Driver can do alpha blending for blits.
DDFXCAPS_BLTALPHA						EQU 00000001h

; Driver can do surface-reconstruction filtering for warped blits.
DDFXCAPS_BLTFILTER						EQU DDFXCAPS_BLTARITHSTRETCHY

; Driver can do alpha blending for overlays.
DDFXCAPS_OVERLAYALPHA					EQU 00000004h

; Driver can do surface-reconstruction filtering for warped overlays.
DDFXCAPS_OVERLAYFILTER					EQU DDFXCAPS_OVERLAYARITHSTRETCHY

; ###################################
; DIRECTDRAW STEREO VIEW CAPABILITIES
; ###################################

; This flag used to be DDSVCAPS_ENIGMA, which is now obsolete
DDSVCAPS_RESERVED1						EQU 00000001h

; This flag used to be DDSVCAPS_FLICKER, which is now obsolete
DDSVCAPS_RESERVED2						EQU 00000002h

; This flag used to be DDSVCAPS_REDBLUE, which is now obsolete
DDSVCAPS_RESERVED3						EQU 00000004h

; This flag used to be DDSVCAPS_SPLIT, which is now obsolete
DDSVCAPS_RESERVED4						EQU 00000008h

; The stereo view is accomplished with switching technology
DDSVCAPS_STEREOSEQUENTIAL				EQU 00000010h

; ##############################
; DIRECTDRAWPALETTE CAPABILITIES
; ##############################

; Index is 4 bits.	There are sixteen color entries in the palette table.
DDPCAPS_4BIT							EQU 00000001h

; Index is onto a 8 bit color index.  This field is only valid with the
; DDPCAPS_1BIT, DDPCAPS_2BIT or DDPCAPS_4BIT capability and the target
; surface is in 8bpp. Each color entry is one byte long and is an index
; into destination surface's 8bpp palette.
DDPCAPS_8BITENTRIES						EQU 00000002h

; Index is 8 bits.	There are 256 color entries in the palette table.
DDPCAPS_8BIT							EQU 00000004h

; Indicates that this DIRECTDRAWPALETTE should use the palette color array
; passed into the lpDDColorArray parameter to initialize the DIRECTDRAWPALETTE
; object.
; This flag is obsolete. DirectDraw always initializes the color array from
; the lpDDColorArray parameter. The definition remains for source-level
; compatibility.
DDPCAPS_INITIALIZE						EQU 00000000h

; This palette is the one attached to the primary surface.	Changing this
; table has immediate effect on the display unless DDPSETPAL_VSYNC is specified
; and supported.
DDPCAPS_PRIMARYSURFACE					EQU 00000010h

; This palette is the one attached to the primary surface left.  Changing
; this table has immediate effect on the display for the left eye unless
; DDPSETPAL_VSYNC is specified and supported.
DDPCAPS_PRIMARYSURFACELEFT				EQU 00000020h

; This palette can have all 256 entries defined
DDPCAPS_ALLOW256						EQU 00000040h

; This palette can have modifications to it synced with the monitors
; refresh rate.
DDPCAPS_VSYNC							EQU 00000080h

; Index is 1 bit.  There are two color entries in the palette table.
DDPCAPS_1BIT							EQU 00000100h

; Index is 2 bit.  There are four color entries in the palette table.
DDPCAPS_2BIT							EQU 00000200h

; The peFlags member of PALETTEENTRY denotes an 8 bit alpha value
DDPCAPS_ALPHA							EQU 00000400h

; ####################################
; DIRECTDRAWPALETTE SETENTRY CONSTANTS
; ####################################

; ####################################
; DIRECTDRAWPALETTE GETENTRY CONSTANTS
; ####################################

; 0 is the only legal value;

; ##########################################
; DIRECTDRAWSURFACE SETPRIVATEDATA CONSTANTS
; ##########################################

; The passed pointer is an IUnknown ptr. The cbData argument to SetPrivateData
; must be set to sizeof(IUnknown*). DirectDraw will call AddRef through this
; pointer and Release when the private data is destroyed. This includes when
; the surface or palette is destroyed before such priovate data is destroyed.
DDSPD_IUNKNOWNPOINTER					EQU 00000001h

; Private data is only valid for the current state of the object,
; as determined by the uniqueness value.
DDSPD_VOLATILE							EQU 00000002h

; ######################################
; DIRECTDRAWSURFACE SETPALETTE CONSTANTS
; ######################################

; ######################################################################
;
; DIRECTDRAW BITDEPTH CONSTANTS
;
; NOTE:  These are only used to indicate supported bit depths.	 These
; are flags only, they are not to be used as an actual bit depth.	The
; absolute numbers 1, 2, 4, 8, 16, 24 and 32 are used to indicate actual
; bit depths in a surface or for changing the display mode.
;
; ######################################################################

; 1 bit per pixel.
DDBD_1									EQU 00004000h

; 2 bits per pixel.
DDBD_2									EQU 00002000h

; 4 bits per pixel.
DDBD_4									EQU 00001000h

; 8 bits per pixel.
DDBD_8									EQU 00000800h

; 16 bits per pixel.
DDBD_16									EQU 00000400h

; 24 bits per pixel.
DDBD_24									EQU 00000200h

; 32 bits per pixel.
DDBD_32									EQU 00000100h

; #########################################
; DIRECTDRAWSURFACE SET/GET COLOR KEY FLAGS
; #########################################

; Set if the structure contains a color space.	Not set if the structure
; contains a single color key.
DDCKEY_COLORSPACE						EQU 00000001h

; Set if the structure specifies a color key or color space which is to be
; used as a destination color key for blt operations.
DDCKEY_DESTBLT							EQU 00000002h

; Set if the structure specifies a color key or color space which is to be
; used as a destination color key for overlay operations.
DDCKEY_DESTOVERLAY						EQU 00000004h

; Set if the structure specifies a color key or color space which is to be
; used as a source color key for blt operations.
DDCKEY_SRCBLT							EQU 00000008h

; Set if the structure specifies a color key or color space which is to be
; used as a source color key for overlay operations.
DDCKEY_SRCOVERLAY						EQU 00000010h

; #####################################
; DIRECTDRAW COLOR KEY CAPABILITY FLAGS
; #####################################

; Supports transparent blting using a color key to identify the replaceable
; bits of the destination surface for RGB colors.
DDCKEYCAPS_DESTBLT						EQU 00000001h

; Supports transparent blting using a color space to identify the replaceable
; bits of the destination surface for RGB colors.
DDCKEYCAPS_DESTBLTCLRSPACE				EQU 00000002h

; Supports transparent blting using a color space to identify the replaceable
; bits of the destination surface for YUV colors.
DDCKEYCAPS_DESTBLTCLRSPACEYUV			EQU 00000004h

; Supports transparent blting using a color key to identify the replaceable
; bits of the destination surface for YUV colors.
DDCKEYCAPS_DESTBLTYUV					EQU 00000008h

; Supports overlaying using colorkeying of the replaceable bits of the surface
; being overlayed for RGB colors.
DDCKEYCAPS_DESTOVERLAY					EQU 00000010h

; Supports a color space as the color key for the destination for RGB colors.
DDCKEYCAPS_DESTOVERLAYCLRSPACE			EQU 00000020h

; Supports a color space as the color key for the destination for YUV colors.
DDCKEYCAPS_DESTOVERLAYCLRSPACEYUV		EQU 00000040h

; Supports only one active destination color key value for visible overlay
; surfaces.
DDCKEYCAPS_DESTOVERLAYONEACTIVE			EQU 00000080h

; Supports overlaying using colorkeying of the replaceable bits of the
; surface being overlayed for YUV colors.
DDCKEYCAPS_DESTOVERLAYYUV				EQU 00000100h

; Supports transparent blting using the color key for the source with
; this surface for RGB colors.
DDCKEYCAPS_SRCBLT						EQU 00000200h

; Supports transparent blting using a color space for the source with
; this surface for RGB colors.
DDCKEYCAPS_SRCBLTCLRSPACE				EQU 00000400h

; Supports transparent blting using a color space for the source with
; this surface for YUV colors.
DDCKEYCAPS_SRCBLTCLRSPACEYUV			EQU 00000800h

; Supports transparent blting using the color key for the source with
; this surface for YUV colors.
DDCKEYCAPS_SRCBLTYUV					EQU 00001000h

; Supports overlays using the color key for the source with this
; overlay surface for RGB colors.
DDCKEYCAPS_SRCOVERLAY					EQU 00002000h

; Supports overlays using a color space as the source color key for
; the overlay surface for RGB colors.
DDCKEYCAPS_SRCOVERLAYCLRSPACE			EQU 00004000h

; Supports overlays using a color space as the source color key for
; the overlay surface for YUV colors.
DDCKEYCAPS_SRCOVERLAYCLRSPACEYUV		EQU 00008000h

; Supports only one active source color key value for visible
; overlay surfaces.
DDCKEYCAPS_SRCOVERLAYONEACTIVE			EQU 00010000h

; Supports overlays using the color key for the source with this
; overlay surface for YUV colors.
DDCKEYCAPS_SRCOVERLAYYUV				EQU 00020000h

; there are no bandwidth trade-offs for using colorkey with an overlay
DDCKEYCAPS_NOCOSTOVERLAY				EQU 00040000h

; ############################
; DIRECTDRAW PIXELFORMAT FLAGS
; ############################

; The surface has alpha channel information in the pixel format.
DDPF_ALPHAPIXELS						EQU 00000001h

; The pixel format contains alpha only information
DDPF_ALPHA								EQU 00000002h

; The FourCC code is valid.
DDPF_FOURCC								EQU 00000004h

; The surface is 4-bit color indexed.
DDPF_PALETTEINDEXED4					EQU 00000008h

; The surface is indexed into a palette which stores indices
; into the destination surface's 8-bit palette.
DDPF_PALETTEINDEXEDTO8					EQU 00000010h

; The surface is 8-bit color indexed.
DDPF_PALETTEINDEXED8					EQU 00000020h

; The RGB data in the pixel format structure is valid.
DDPF_RGB								EQU 00000040h

; The surface will accept pixel data in the format specified
; and compress it during the write.
DDPF_COMPRESSED							EQU 00000080h

; The surface will accept RGB data and translate it during
; the write to YUV data.  The format of the data to be written
; will be contained in the pixel format structure.	The DDPF_RGB
; flag will be set.
DDPF_RGBTOYUV							EQU 00000100h

; pixel format is YUV - YUV data in pixel format struct is valid
DDPF_YUV								EQU 00000200h

; pixel format is a z buffer only surface
DDPF_ZBUFFER							EQU 00000400h

; The surface is 1-bit color indexed.
DDPF_PALETTEINDEXED1					EQU 00000800h

; The surface is 2-bit color indexed.
DDPF_PALETTEINDEXED2					EQU 00001000h

; The surface contains Z information in the pixels
DDPF_ZPIXELS							EQU 00002000h

; The surface contains stencil information along with Z
DDPF_STENCILBUFFER						EQU 00004000h

; Premultiplied alpha format -- the color components have been
; premultiplied by the alpha component.
DDPF_ALPHAPREMULT						EQU 00008000h

; Luminance data in the pixel format is valid.
; Use this flag for luminance-only or luminance+alpha surfaces,
; the bit depth is then ddpf.dwLuminanceBitCount.
DDPF_LUMINANCE							EQU 00020000h

; Luminance data in the pixel format is valid.
; Use this flag when hanging luminance off bumpmap surfaces,
; the bit mask for the luminance portion of the pixel is then
; ddpf.dwBumpLuminanceBitMask
DDPF_BUMPLUMINANCE						EQU 00040000h

; Bump map dUdV data in the pixel format is valid.
DDPF_BUMPDUDV							EQU 00080000h

; #########################
; DIRECTDRAW CALLBACK FLAGS
; #########################

; #############################
; DIRECTDRAW ENUMSURFACES FLAGS
; #############################

; Enumerate all of the surfaces that meet the search criterion.
DDENUMSURFACES_ALL						EQU 00000001h

; A search hit is a surface that matches the surface description.
DDENUMSURFACES_MATCH					EQU 00000002h

; A search hit is a surface that does not match the surface description.
DDENUMSURFACES_NOMATCH					EQU 00000004h

; Enumerate the first surface that can be created which meets the search criterion.
DDENUMSURFACES_CANBECREATED				EQU 00000008h

; Enumerate the surfaces that already exist that meet the search criterion.
DDENUMSURFACES_DOESEXIST				EQU 00000010h

; ###############################
; DIRECTDRAW SETDISPLAYMODE FLAGS
; ###############################

; The desired mode is a standard VGA mode
DDSDM_STANDARDVGAMODE					EQU 00000001h

; #################################
; DIRECTDRAW ENUMDISPLAYMODES FLAGS
; #################################

; Enumerate Modes with different refresh rates.  EnumDisplayModes guarantees
; that a particular mode will be enumerated only once.	This flag specifies whether
; the refresh rate is taken into account when determining if a mode is unique.
DDEDM_REFRESHRATES						EQU 00000001h

; Enumerate VGA modes. Specify this flag if you wish to enumerate supported VGA
; modes such as mode 					EQU 13 in addition to the usual ModeX modes (which are always
; enumerated if the application has previously called SetCooperativeLevel with the
; DDSCL_ALLOWMODEX flag set).
DDEDM_STANDARDVGAMODES					EQU 00000002h

; ####################################
; DIRECTDRAW SETCOOPERATIVELEVEL FLAGS
; ####################################

; Exclusive mode owner will be responsible for the entire primary surface.
; GDI can be ignored. used with DD
DDSCL_FULLSCREEN						EQU 00000001h

; allow CTRL_ALT_DEL to work while in fullscreen exclusive mode
DDSCL_ALLOWREBOOT						EQU 00000002h

; prevents DDRAW from modifying the application window.
; prevents DDRAW from minimize/restore the application window on activation.
DDSCL_NOWINDOWCHANGES					EQU 00000004h

; app wants to work as a regular Windows application
DDSCL_NORMAL							EQU 00000008h

; app wants exclusive access
DDSCL_EXCLUSIVE							EQU 00000010h

; app can deal with non-windows display modes
DDSCL_ALLOWMODEX						EQU 00000040h

; this window will receive the focus messages
DDSCL_SETFOCUSWINDOW					EQU 00000080h

; this window is associated with the DDRAW object and will
; cover the screen in fullscreen mode
DDSCL_SETDEVICEWINDOW					EQU 00000100h

; app wants DDRAW to create a window to be associated with the
; DDRAW object
DDSCL_CREATEDEVICEWINDOW				EQU 00000200h

; App explicitly asks DDRAW/D3D to be multithread safe. This makes D3D
; take the global crtisec more frequently.
DDSCL_MULTITHREADED						EQU 00000400h

; App specifies that it would like to keep the FPU set up for optimal Direct3D
; performance (single precision and exceptions disabled) so Direct3D
; does not need to explicitly set the FPU each time. This is assumed by
; default in DirectX 7. See also DDSCL_FPUPRESERVE
DDSCL_FPUSETUP							EQU 00000800h

; App specifies that it needs either double precision FPU or FPU exceptions
; enabled. This makes Direct3D explicitly set the FPU state eah time it is
; called. Setting the flag will reduce Direct3D performance. The flag is
; assumed by default in DirectX 6 and earlier. See also DDSCL_FPUSETUP
DDSCL_FPUPRESERVE						EQU 00001000h

; ####################
; DIRECTDRAW BLT FLAGS
; ####################

; Use the alpha information in the pixel format or the alpha channel surface
; attached to the destination surface as the alpha channel for this blt.
DDBLT_ALPHADEST							EQU 00000001h

; Use the dwConstAlphaDest field in the DDBLTFX structure as the alpha channel
; for the destination surface for this blt.
DDBLT_ALPHADESTCONSTOVERRIDE			EQU 00000002h

; The NEG suffix indicates that the destination surface becomes more
; transparent as the alpha value increases. (0 is opaque)
DDBLT_ALPHADESTNEG						EQU 00000004h

; Use the lpDDSAlphaDest field in the DDBLTFX structure as the alpha
; channel for the destination for this blt.
DDBLT_ALPHADESTSURFACEOVERRIDE			EQU 00000008h

; Use the dwAlphaEdgeBlend field in the DDBLTFX structure as the alpha channel
; for the edges of the image that border the color key colors.
DDBLT_ALPHAEDGEBLEND					EQU 00000010h

; Use the alpha information in the pixel format or the alpha channel surface
; attached to the source surface as the alpha channel for this blt.
DDBLT_ALPHASRC							EQU 00000020h

; Use the dwConstAlphaSrc field in the DDBLTFX structure as the alpha channel
; for the source for this blt.
DDBLT_ALPHASRCCONSTOVERRIDE				EQU 00000040h

; The NEG suffix indicates that the source surface becomes more transparent
; as the alpha value increases. (0 is opaque)
DDBLT_ALPHASRCNEG						EQU 00000080h

; Use the lpDDSAlphaSrc field in the DDBLTFX structure as the alpha channel
; for the source for this blt.
DDBLT_ALPHASRCSURFACEOVERRIDE			EQU 00000100h

; Do this blt asynchronously through the FIFO in the order received.  If
; there is no room in the hardware FIFO fail the call.
DDBLT_ASYNC								EQU 00000200h

; Uses the dwFillColor field in the DDBLTFX structure as the RGB color
; to fill the destination rectangle on the destination surface with.
DDBLT_COLORFILL							EQU 00000400h

; Uses the dwDDFX field in the DDBLTFX structure to specify the effects
; to use for the blt.
DDBLT_DDFX								EQU 00000800h

; Uses the dwDDROPS field in the DDBLTFX structure to specify the ROPS
; that are not part of the Win32 API.
DDBLT_DDROPS							EQU 00001000h

; Use the color key associated with the destination surface.
DDBLT_KEYDEST							EQU 00002000h

; Use the dckDestColorkey field in the DDBLTFX structure as the color key
; for the destination surface.
DDBLT_KEYDESTOVERRIDE					EQU 00004000h

; Use the color key associated with the source surface.
DDBLT_KEYSRC							EQU 00008000h

; Use the dckSrcColorkey field in the DDBLTFX structure as the color key
; for the source surface.
DDBLT_KEYSRCOVERRIDE					EQU 00010000h

; Use the dwROP field in the DDBLTFX structure for the raster operation
; for this blt.  These ROPs are the same as the ones defined in the Win32 API.
DDBLT_ROP								EQU 00020000h

; Use the dwRotationAngle field in the DDBLTFX structure as the angle
; (specified in 1/100th of a degree) to rotate the surface.
DDBLT_ROTATIONANGLE						EQU 00040000h

; Z-buffered blt using the z-buffers attached to the source and destination
; surfaces and the dwZBufferOpCode field in the DDBLTFX structure as the
; z-buffer opcode.
DDBLT_ZBUFFER							EQU 00080000h

; Z-buffered blt using the dwConstDest Zfield and the dwZBufferOpCode field
; in the DDBLTFX structure as the z-buffer and z-buffer opcode respectively
; for the destination.
DDBLT_ZBUFFERDESTCONSTOVERRIDE			EQU 00100000h

; Z-buffered blt using the lpDDSDestZBuffer field and the dwZBufferOpCode
; field in the DDBLTFX structure as the z-buffer and z-buffer opcode
; respectively for the destination.
DDBLT_ZBUFFERDESTOVERRIDE				EQU 00200000h

; Z-buffered blt using the dwConstSrcZ field and the dwZBufferOpCode field
; in the DDBLTFX structure as the z-buffer and z-buffer opcode respectively
; for the source.
DDBLT_ZBUFFERSRCCONSTOVERRIDE			EQU 00400000h

; Z-buffered blt using the lpDDSSrcZBuffer field and the dwZBufferOpCode
; field in the DDBLTFX structure as the z-buffer and z-buffer opcode
; respectively for the source.
DDBLT_ZBUFFERSRCOVERRIDE				EQU 00800000h

; wait until the device is ready to handle the blt
; this will cause blt to not return DDERR_WASSTILLDRAWING
DDBLT_WAIT								EQU 01000000h

; Uses the dwFillDepth field in the DDBLTFX structure as the depth value
; to fill the destination rectangle on the destination Z-buffer surface
; with.
DDBLT_DEPTHFILL							EQU 02000000h

; Return immediately (with DDERR_WASSTILLDRAWING) if the device is not
; ready to schedule the blt at the time Blt() is called.
DDBLT_DONOTWAIT							EQU 08000000h

; These flags indicate a presentation blt (i.e. a blt
; that moves surface contents from an offscreen back buffer to the primary
; surface). The driver is not allowed to "queue"  more than three such blts.
; The "end" of the presentation blt is indicated, since the
; blt may be clipped, in which case the runtime will call the driver with 
; several blts. All blts (even if not clipped) are tagged with DDBLT_PRESENTATION
; and the last (even if not clipped) additionally with DDBLT_LAST_PRESENTATION.
; Thus the true rule is that the driver must not schedule a DDBLT_PRESENTATION
; blt if there are 3 or more DDBLT_PRESENTLAST blts in the hardware pipe.
; If there are such blts in the pipe, the driver should return DDERR_WASSTILLDRAWING
; until the oldest queued DDBLT_LAST_PRESENTATION blts has been retired (i.e. the
; pixels have been actually written to the primary surface). Once the oldest blt
; has been retired, the driver is free to schedule the current blt.
; The goal is to provide a mechanism whereby the device's hardware queue never
; gets more than 3 frames ahead of the frames being generated by the application.
; When excessive queueing occurs, applications become unusable because the application
; visibly lags user input, and such problems make windowed interactive applications impossible.
; Some drivers may not have sufficient knowledge of their hardware's FIFO to know
; when a certain blt has been retired. Such drivers should code cautiously, and 
; simply not allow any frames to be queued at all. DDBLT_LAST_PRESENTATION should cause
; such drivers to return DDERR_WASSTILLDRAWING until the accelerator is completely
; finished- exactly as if the application had called Lock on the source surface
; before calling Blt. 
; In other words, the driver is allowed and encouraged to 
; generate as much latency as it can, but never more than 3 frames worth.
; Implementation detail: Drivers should count blts against the SOURCE surface, not
; against the primary surface. This enables multiple parallel windowed application
; to function more optimally.
; This flag is passed only to DX8 or higher drivers.
;
; APPLICATIONS DO NOT SET THESE FLAGS. THEY ARE SET BY THE DIRECTDRAW RUNTIME.
DDBLT_PRESENTATION						EQU 10000000h
DDBLT_LAST_PRESENTATION					EQU 20000000h

; If DDBLT_EXTENDED_FLAGS is set, then the driver should re-interpret
; other flags according to the definitions that follow.
; For example, bit 0 (EQU 00000001L) means DDBLT_ALPHADEST, unless
; DDBLT_EXTENDED_FLAGS is also set, in which case bit 0 means
; DDBLT_EXTENDED_LINEAR_CONTENT.
; Only DirectX9 and higher drivers will be given extended blt flags.
; Only flags explicitly mentioned here should be re-interpreted.
; All other flags retain their original meanings.
;
; List of re-interpreted flags:
;
; Bit Hex value   New meaning								   old meaning
; ---------------------------------------------------------------
;  2  0x00000004	DDBLT_EXTENDED_LINEAR_CONTENT				 DDBLT_ALPHADESTNEG
;  4  0x00000010	DDBLT_EXTENDED_PRESENTATION_STRETCHFACTOR	 DDBLT_ALPHAEDGEBLEND
;
;
; NOTE: APPLICATIONS SHOULD NOT SET THIS FLAG. THIS FLAG IS INTENDED
; FOR USE BY THE DIRECT3D RUNTIME.
DDBLT_EXTENDED_FLAGS					EQU 40000000h

; EXTENDED FLAG. SEE DEFINITION OF DDBLT_EXTENDED_FLAGS.
; This flag indidcates that the source surface contains content in a
; linear color space. The driver may perform gamma correction to the
; desktop color space (i.e. sRGB, gamma 2.2) as part of this blt.
; If the device can perform such a conversion as part of the copy,
; the driver should also set D3DCAPS3_LINEAR_TO_SRGB_PRESENTATION
;
; NOTE: APPLICATIONS SHOULD NOT SET THIS FLAG. THIS FLAG IS INTENDED
; FOR USE BY THE DIRECT3D RUNTIME. Use IDirect3DSwapChain9::Present
; and specify D3DPRESENT_LINEAR_CONTENT in order to use this functionality.
DDBLT_EXTENDED_LINEAR_CONTENT			EQU 00000004h

; #############
; BLTFAST FLAGS
; #############

DDBLTFAST_NOCOLORKEY					EQU 00000000
DDBLTFAST_SRCCOLORKEY					EQU 00000001
DDBLTFAST_DESTCOLORKEY					EQU 00000002
DDBLTFAST_WAIT							EQU 00000010
DDBLTFAST_DONOTWAIT						EQU 00000020
; ##########
; FLIP FLAGS
; ##########

DDFLIP_WAIT							 	EQU 00000001h
; Indicates that the target surface contains the even field of video data.
; This flag is only valid with an overlay surface.
DDFLIP_EVEN							 	EQU 00000002h

; Indicates that the target surface contains the odd field of video data.
; This flag is only valid with an overlay surface.
DDFLIP_ODD							 	EQU 00000004h

; Causes DirectDraw to perform the physical flip immediately and return
; to the application. Typically, what was the front buffer but is now the back
; buffer will still be visible (depending on timing) until the next vertical
; retrace. Subsequent operations involving the two flipped surfaces will
; not check to see if the physical flip has finished (i.e. will not return
; DDERR_WASSTILLDRAWING for that reason (but may for other reasons)).
; This allows an application to perform Flips at a higher frequency than the
; monitor refresh rate, but may introduce visible artifacts.
; Only effective if DDCAPS2_FLIPNOVSYNC is set. If that bit is not set,
; DDFLIP_NOVSYNC has no effect.
DDFLIP_NOVSYNC						 	EQU 00000008h

; Flip Interval Flags. These flags indicate how many vertical retraces to wait between
; each flip. The default is one. DirectDraw will return DDERR_WASSTILLDRAWING for each
; surface involved in the flip until the specified number of vertical retraces has
; ocurred. Only effective if DDCAPS2_FLIPINTERVAL is set. If that bit is not set,
; DDFLIP_INTERVALn has no effect.

; DirectDraw will flip on every other vertical sync
DDFLIP_INTERVAL2					 	EQU 02000000h

; DirectDraw will flip on every third vertical sync
DDFLIP_INTERVAL3					 	EQU 03000000h

; DirectDraw will flip on every fourth vertical sync
DDFLIP_INTERVAL4					 	EQU 04000000h

; DirectDraw will flip and display a main stereo surface
DDFLIP_STEREO						 	EQU 00000010h

; On IDirectDrawSurface7 and higher interfaces, the default is DDFLIP_WAIT. If you wish
; to override the default and use time when the accelerator is busy (as denoted by
; the DDERR_WASSTILLDRAWING return code) then use DDFLIP_DONOTWAIT.
DDFLIP_DONOTWAIT					 	EQU 00000020h

; ################################
; DIRECTDRAW SURFACE OVERLAY FLAGS
; ################################

; Use the alpha information in the pixel format or the alpha channel surface
; attached to the destination surface as the alpha channel for the
; destination overlay.
DDOVER_ALPHADEST						EQU 00000001h

; Use the dwConstAlphaDest field in the DDOVERLAYFX structure as the
; destination alpha channel for this overlay.
DDOVER_ALPHADESTCONSTOVERRIDE			EQU 00000002h

; The NEG suffix indicates that the destination surface becomes more
; transparent as the alpha value increases.
DDOVER_ALPHADESTNEG						EQU 00000004h

; Use the lpDDSAlphaDest field in the DDOVERLAYFX structure as the alpha
; channel destination for this overlay.
DDOVER_ALPHADESTSURFACEOVERRIDE			EQU 00000008h

; Use the dwAlphaEdgeBlend field in the DDOVERLAYFX structure as the alpha
; channel for the edges of the image that border the color key colors.
DDOVER_ALPHAEDGEBLEND					EQU 00000010h

; Use the alpha information in the pixel format or the alpha channel surface
; attached to the source surface as the source alpha channel for this overlay.
DDOVER_ALPHASRC							EQU 00000020h

; Use the dwConstAlphaSrc field in the DDOVERLAYFX structure as the source
; alpha channel for this overlay.
DDOVER_ALPHASRCCONSTOVERRIDE			EQU 00000040h

; The NEG suffix indicates that the source surface becomes more transparent
; as the alpha value increases.
DDOVER_ALPHASRCNEG						EQU 00000080h

; Use the lpDDSAlphaSrc field in the DDOVERLAYFX structure as the alpha channel
; source for this overlay.
DDOVER_ALPHASRCSURFACEOVERRIDE			EQU 00000100h

; Turn this overlay off.
DDOVER_HIDE								EQU 00000200h

; Use the color key associated with the destination surface.
DDOVER_KEYDEST							EQU 00000400h

; Use the dckDestColorkey field in the DDOVERLAYFX structure as the color key
; for the destination surface
DDOVER_KEYDESTOVERRIDE					EQU 00000800h

; Use the color key associated with the source surface.
DDOVER_KEYSRC							EQU 00001000h

; Use the dckSrcColorkey field in the DDOVERLAYFX structure as the color key
; for the source surface.
DDOVER_KEYSRCOVERRIDE					EQU 00002000h

; Turn this overlay on.
DDOVER_SHOW								EQU 00004000h

; Add a dirty rect to an emulated overlayed surface.
DDOVER_ADDDIRTYRECT						EQU 00008000h

; Redraw all dirty rects on an emulated overlayed surface.
DDOVER_REFRESHDIRTYRECTS				EQU 00010000h

; Redraw the entire surface on an emulated overlayed surface.
DDOVER_REFRESHALL					   	EQU 00020000h

; Use the overlay FX flags to define special overlay FX
DDOVER_DDFX								EQU 00080000h

; Autoflip the overlay when ever the video port autoflips
DDOVER_AUTOFLIP							EQU 00100000h

; Display each field of video port data individually without
; causing any jittery artifacts
DDOVER_BOB								EQU 00200000h

; Indicates that bob/weave decisions should not be overridden by other
; interfaces.
DDOVER_OVERRIDEBOBWEAVE					EQU 00400000h

; Indicates that the surface memory is composed of interleaved fields.
DDOVER_INTERLEAVED						EQU 00800000h

; Indicates that bob will be performed using hardware rather than
; software or emulated.
DDOVER_BOBHARDWARE						EQU 01000000h

; Indicates that overlay FX structure contains valid ARGB scaling factors.
DDOVER_ARGBSCALEFACTORS					EQU 02000000h

; Indicates that ARGB scaling factors can be degraded to fit driver capabilities.
DDOVER_DEGRADEARGBSCALING				EQU 04000000h

; ############################
; DIRECTDRAWSURFACE LOCK FLAGS
; ############################

; The default.	Set to indicate that Lock should return a valid memory pointer
; to the top of the specified rectangle.  If no rectangle is specified then a
; pointer to the top of the surface is returned.
DDLOCK_SURFACEMEMORYPTR					EQU 00000000h

; Set to indicate that Lock should wait until it can obtain a valid memory
; pointer before returning.  If this bit is set, Lock will never return
; DDERR_WASSTILLDRAWING.
DDLOCK_WAIT								EQU 00000001h

; Set if an event handle is being passed to Lock.  Lock will trigger the event
; when it can return the surface memory pointer requested.
DDLOCK_EVENT							EQU 00000002h

; Indicates that the surface being locked will only be read from.
DDLOCK_READONLY							EQU 00000010h

; Indicates that the surface being locked will only be written to
DDLOCK_WRITEONLY						EQU 00000020h

; Indicates that a system wide lock should not be taken when this surface
; is locked. This has several advantages (cursor responsiveness, ability
; to call more Windows functions, easier debugging) when locking video
; memory surfaces. However, an application specifying this flag must
; comply with a number of conditions documented in the help file.
; Furthermore, this flag cannot be specified when locking the primary.
DDLOCK_NOSYSLOCK						EQU 00000800h

; Used only with Direct3D Vertex Buffer Locks. Indicates that no vertices
; that were referred to in Draw*PrimtiveVB calls since the start of the
; frame (or the last lock without this flag) will be modified during the
; lock. This can be useful when one is only appending data to the vertex
; buffer
DDLOCK_NOOVERWRITE						EQU 00001000h

; Indicates that no assumptions will be made about the contents of the
; surface or vertex buffer during this lock.
; This enables two things:
; -    Direct3D or the driver may provide an alternative memory
;	   area as the vertex buffer. This is useful when one plans to clear the
;	   contents of the vertex buffer and fill in new data.
; -    Drivers sometimes store surface data in a re-ordered format.
;	   When the application locks the surface, the driver is forced to un-re-order
;	   the surface data before allowing the application to see the surface contents.
;	   This flag is a hint to the driver that it can skip the un-re-ordering process
;	   since the application plans to overwrite every single pixel in the surface
;	   or locked rectangle (and so erase any un-re-ordered pixels anyway).
;	   Applications should always set this flag when they intend to overwrite the entire
;	   surface or locked rectangle.
DDLOCK_DISCARDCONTENTS					EQU 00002000h

; DDLOCK_OKTOSWAP is an older, less informative name for DDLOCK_DISCARDCONTENTS
DDLOCK_OKTOSWAP							EQU 00002000h

; On IDirectDrawSurface7 and higher interfaces, the default is DDLOCK_WAIT. If you wish
; to override the default and use time when the accelerator is busy (as denoted by
; the DDERR_WASSTILLDRAWING return code) then use DDLOCK_DONOTWAIT.
DDLOCK_DONOTWAIT						EQU 00004000h

; This indicates volume texture lock with front and back specified.
DDLOCK_HASVOLUMETEXTUREBOXRECT			EQU 00008000h

; This indicates that the driver should not update dirty rect information for this lock.
DDLOCK_NODIRTYUPDATE					EQU 00010000h

; ################################
; DIRECTDRAWSURFACE PAGELOCK FLAGS
; ################################

; No flags defined at present

; ##################################
; DIRECTDRAWSURFACE PAGEUNLOCK FLAGS
; ##################################

; No flags defined at present

; ##############################
; DIRECTDRAWSURFACE BLT FX FLAGS
; ##############################

; If stretching, use arithmetic stretching along the Y axis for this blt.
DDBLTFX_ARITHSTRETCHY					EQU 00000001h

; Do this blt mirroring the surface left to right.	Spin the
; surface around its y-axis.
DDBLTFX_MIRRORLEFTRIGHT					EQU 00000002h

; Do this blt mirroring the surface up and down.  Spin the surface
; around its x-axis.
DDBLTFX_MIRRORUPDOWN					EQU 00000004h

; Schedule this blt to avoid tearing.
DDBLTFX_NOTEARING						EQU 00000008h

; Do this blt rotating the surface one hundred and eighty degrees.
DDBLTFX_ROTATE180						EQU 00000010h

; Do this blt rotating the surface two hundred and seventy degrees.
DDBLTFX_ROTATE270						EQU 00000020h

; Do this blt rotating the surface ninety degrees.
DDBLTFX_ROTATE90						EQU 00000040h

; Do this z blt using dwZBufferLow and dwZBufferHigh as  range values
; specified to limit the bits copied from the source surface.
DDBLTFX_ZBUFFERRANGE					EQU 00000080h

; Do this z blt adding the dwZBufferBaseDest to each of the sources z values
; before comparing it with the desting z values.
DDBLTFX_ZBUFFERBASEDEST					EQU 00000100h

; ##################################
; DIRECTDRAWSURFACE OVERLAY FX FLAGS
; ##################################

; If stretching, use arithmetic stretching along the Y axis for this overlay.
DDOVERFX_ARITHSTRETCHY					EQU 00000001h

; Mirror the overlay across the vertical axis
DDOVERFX_MIRRORLEFTRIGHT				EQU 00000002h

; Mirror the overlay across the horizontal axis
DDOVERFX_MIRRORUPDOWN					EQU 00000004h

; Deinterlace the overlay, if possible
DDOVERFX_DEINTERLACE					EQU 00000008h

; #####################################
; DIRECTDRAW WAITFORVERTICALBLANK FLAGS
; #####################################

; return when the vertical blank interval begins
DDWAITVB_BLOCKBEGIN						EQU 00000001h

; set up an event to trigger when the vertical blank begins
DDWAITVB_BLOCKBEGINEVENT				EQU 00000002h

; return when the vertical blank interval ends and display begins
DDWAITVB_BLOCKEND						EQU 00000004h

; ##############################
; DIRECTDRAW GETFLIPSTATUS FLAGS
; ##############################

; is it OK to flip now?
DDGFS_CANFLIP							EQU 00000001h

; is the last flip finished?
DDGFS_ISFLIPDONE						EQU 00000002h

; #############################
; DIRECTDRAW GETBLTSTATUS FLAGS
; #############################

; is it OK to blt now?
DDGBS_CANBLT							EQU 00000001h

; is the blt to the surface finished?
DDGBS_ISBLTDONE							EQU 00000002h

; ##################################
; DIRECTDRAW ENUMOVERLAYZORDER FLAGS
; ##################################

; Enumerate overlays back to front.
DDENUMOVERLAYZ_BACKTOFRONT				EQU 00000000h

; Enumerate overlays front to back
DDENUMOVERLAYZ_FRONTTOBACK				EQU 00000001h

; ####################################
; DIRECTDRAW UPDATEOVERLAYZORDER FLAGS
; ####################################

; Send overlay to front
DDOVERZ_SENDTOFRONT						EQU 00000000h

; Send overlay to back
DDOVERZ_SENDTOBACK						EQU 00000001h

; Move Overlay forward
DDOVERZ_MOVEFORWARD						EQU 00000002h

; Move Overlay backward
DDOVERZ_MOVEBACKWARD					EQU 00000003h

; Move Overlay in front of relative surface
DDOVERZ_INSERTINFRONTOF					EQU 00000004h

; Move Overlay in back of relative surface
DDOVERZ_INSERTINBACKOF					EQU 00000005h

; #############################
; DIRECTDRAW SETGAMMARAMP FLAGS
; #############################

; Request calibrator to adjust the gamma ramp according to the physical
; properties of the display so that the result should appear identical
; on all systems.
DDSGR_CALIBRATE						   	EQU 00000001h

; ##############################
; DIRECTDRAW STARTMODETEST FLAGS
; ##############################

; Indicates that the mode being tested has passed
DDSMT_ISTESTREQUIRED					EQU 00000001h

; #############################
; DIRECTDRAW EVALUATEMODE FLAGS
; #############################

; Indicates that the mode being tested has passed
DDEM_MODEPASSED						   	EQU 00000001h

; Indicates that the mode being tested has failed
DDEM_MODEFAILED						   	EQU 00000002h

; #############################################################################
;
;
; DIRECTDRAW RETURN CODES
;
; The return values from DirectDraw Commands and Surface that return an HRESULT
; are codes from DirectDraw concerning the results of the action
; requested by DirectDraw.
;
; #############################################################################

; Status is OK
;
; Issued by: DirectDraw Commands and all callbacks

DD_OK									EQU S_OK
DD_FALSE								EQU S_FALSE
; #######################################################################
;
; DIRECTDRAW ENUMCALLBACK RETURN VALUES
;
; EnumCallback returns are used to control the flow of the DIRECTDRAW and
; DIRECTDRAWSURFACE object enumerations.   They can only be returned by
; enumeration callback routines.
;
; #######################################################################

; stop the enumeration
DDENUMRET_CANCEL						EQU 0

; continue the enumeration
DDENUMRET_OK							EQU 1

; #################################################################
;
; DIRECTDRAW ERRORS
;
; Errors are represented by negative values and cannot be combined.
;
; #################################################################

; This object is already initialized
DDERR_ALREADYINITIALIZED				EQU MAKE_DDHRESULT( 5 )

; This surface can not be attached to the requested surface.
DDERR_CANNOTATTACHSURFACE				EQU MAKE_DDHRESULT( 10 )

; This surface can not be detached from the requested surface.
DDERR_CANNOTDETACHSURFACE				EQU MAKE_DDHRESULT( 20 )

; Support is currently not available.
DDERR_CURRENTLYNOTAVAIL					EQU MAKE_DDHRESULT( 40 )

; An exception was encountered while performing the requested operation
DDERR_EXCEPTION							EQU MAKE_DDHRESULT( 55 )

; Generic failure.
DDERR_GENERIC							EQU E_FAIh

; Height of rectangle provided is not a multiple of reqd alignment
DDERR_HEIGHTALIGN						EQU MAKE_DDHRESULT( 90 )

; Unable to match primary surface creation request with existing
; primary surface.
DDERR_INCOMPATIBLEPRIMARY				EQU MAKE_DDHRESULT( 95 )

; One or more of the caps bits passed to the callback are incorrect.
DDERR_INVALIDCAPS						EQU MAKE_DDHRESULT( 100 )

; DirectDraw does not support provided Cliplist.
DDERR_INVALIDCLIPLIST					EQU MAKE_DDHRESULT( 110 )

; DirectDraw does not support the requested mode
DDERR_INVALIDMODE						EQU MAKE_DDHRESULT( 120 )

; DirectDraw received a pointer that was an invalid DIRECTDRAW object.
DDERR_INVALIDOBJECT						EQU MAKE_DDHRESULT( 130 )

; One or more of the parameters passed to the callback function are
; incorrect.
DDERR_INVALIDPARAMS						EQU E_INVALIDARG

; pixel format was invalid as specified
DDERR_INVALIDPIXELFORMAT				EQU MAKE_DDHRESULT( 145 )

; Rectangle provided was invalid.
DDERR_INVALIDRECT						EQU MAKE_DDHRESULT( 150 )

; Operation could not be carried out because one or more surfaces are locked
DDERR_LOCKEDSURFACES					EQU MAKE_DDHRESULT( 160 )

; There is no 3D present.
DDERR_NO3D								EQU MAKE_DDHRESULT( 170 )

; Operation could not be carried out because there is no alpha accleration
; hardware present or available.
DDERR_NOALPHAHW							EQU MAKE_DDHRESULT( 180 )

; Operation could not be carried out because there is no stereo
; hardware present or available.
DDERR_NOSTEREOHARDWARE					EQU MAKE_DDHRESULT( 181 )

; Operation could not be carried out because there is no hardware
; present which supports stereo surfaces
DDERR_NOSURFACELEFT						EQU MAKE_DDHRESULT( 182 )

; no clip list available
DDERR_NOCLIPLIST						EQU MAKE_DDHRESULT( 205 )

; Operation could not be carried out because there is no color conversion
; hardware present or available.
DDERR_NOCOLORCONVHW						EQU MAKE_DDHRESULT( 210 )

; Create function called without DirectDraw object method SetCooperativeLevel
; being called.
DDERR_NOCOOPERATIVELEVELSET				EQU MAKE_DDHRESULT( 212 )

; Surface doesn't currently have a color key
DDERR_NOCOLORKEY						EQU MAKE_DDHRESULT( 215 )

; Operation could not be carried out because there is no hardware support
; of the dest color key.
DDERR_NOCOLORKEYHW						EQU MAKE_DDHRESULT( 220 )

; No DirectDraw support possible with current display driver
DDERR_NODIRECTDRAWSUPPORT				EQU MAKE_DDHRESULT( 222 )

; Operation requires the application to have exclusive mode but the
; application does not have exclusive mode.
DDERR_NOEXCLUSIVEMODE					EQU MAKE_DDHRESULT( 225 )

; Flipping visible surfaces is not supported.
DDERR_NOFLIPHW							EQU MAKE_DDHRESULT( 230 )

; There is no GDI present.
DDERR_NOGDI								EQU MAKE_DDHRESULT( 240 )

; Operation could not be carried out because there is no hardware present
; or available.
DDERR_NOMIRRORHW						EQU MAKE_DDHRESULT( 250 )

; Requested item was not found
DDERR_NOTFOUND							EQU MAKE_DDHRESULT( 255 )

; Operation could not be carried out because there is no overlay hardware
; present or available.
DDERR_NOOVERLAYHW						EQU MAKE_DDHRESULT( 260 )

; Operation could not be carried out because the source and destination
; rectangles are on the same surface and overlap each other.
DDERR_OVERLAPPINGRECTS					EQU MAKE_DDHRESULT( 270 )

; Operation could not be carried out because there is no appropriate raster
; op hardware present or available.
DDERR_NORASTEROPHW						EQU MAKE_DDHRESULT( 280 )

; Operation could not be carried out because there is no rotation hardware
; present or available.
DDERR_NOROTATIONHW						EQU MAKE_DDHRESULT( 290 )

; Operation could not be carried out because there is no hardware support
; for stretching
DDERR_NOSTRETCHHW						EQU MAKE_DDHRESULT( 310 )

; DirectDrawSurface is not in 4 bit color palette and the requested operation
; requires 4 bit color palette.
DDERR_NOT4BITCOLOR						EQU MAKE_DDHRESULT( 316 )

; DirectDrawSurface is not in 4 bit color index palette and the requested
; operation requires 4 bit color index palette.
DDERR_NOT4BITCOLORINDEX					EQU MAKE_DDHRESULT( 317 )

; DirectDraw Surface is not in 8 bit color mode and the requested operation
; requires 8 bit color.
DDERR_NOT8BITCOLOR						EQU MAKE_DDHRESULT( 320 )

; Operation could not be carried out because there is no texture mapping
; hardware present or available.
DDERR_NOTEXTUREHW						EQU MAKE_DDHRESULT( 330 )

; Operation could not be carried out because there is no hardware support
; for vertical blank synchronized operations.
DDERR_NOVSYNCHW							EQU MAKE_DDHRESULT( 335 )

; Operation could not be carried out because there is no hardware support
; for zbuffer blting.
DDERR_NOZBUFFERHW						EQU MAKE_DDHRESULT( 340 )

; Overlay surfaces could not be z layered based on their BltOrder because
; the hardware does not support z layering of overlays.
DDERR_NOZOVERLAYHW						EQU MAKE_DDHRESULT( 350 )

; The hardware needed for the requested operation has already been
; allocated.
DDERR_OUTOFCAPS							EQU MAKE_DDHRESULT( 360 )

; DirectDraw does not have enough memory to perform the operation.
DDERR_OUTOFMEMORY						EQU E_OUTOFMEMORY

; DirectDraw does not have enough memory to perform the operation.
DDERR_OUTOFVIDEOMEMORY					EQU MAKE_DDHRESULT( 380 )

; hardware does not support clipped overlays
DDERR_OVERLAYCANTCLIP					EQU MAKE_DDHRESULT( 382 )

; Can only have ony color key active at one time for overlays
DDERR_OVERLAYCOLORKEYONLYONEACTIVE		EQU MAKE_DDHRESULT( 384 )

; Access to this palette is being refused because the palette is already
; locked by another thread.
DDERR_PALETTEBUSY						EQU MAKE_DDHRESULT( 387 )

; No src color key specified for this operation.
DDERR_COLORKEYNOTSET					EQU MAKE_DDHRESULT( 400 )

; This surface is already attached to the surface it is being attached to.
DDERR_SURFACEALREADYATTACHED			EQU MAKE_DDHRESULT( 410 )

; This surface is already a dependency of the surface it is being made a
; dependency of.
DDERR_SURFACEALREADYDEPENDENT			EQU MAKE_DDHRESULT( 420 )

; Access to this surface is being refused because the surface is already
; locked by another thread.
DDERR_SURFACEBUSY						EQU MAKE_DDHRESULT( 430 )

; Access to this surface is being refused because no driver exists
; which can supply a pointer to the surface.
; This is most likely to happen when attempting to lock the primary
; surface when no DCI provider is present.
; Will also happen on attempts to lock an optimized surface.
DDERR_CANTLOCKSURFACE					EQU MAKE_DDHRESULT( 435 )

; Access to Surface refused because Surface is obscured.
DDERR_SURFACEISOBSCURED					EQU MAKE_DDHRESULT( 440 )

; Access to this surface is being refused because the surface is gone.
; The DIRECTDRAWSURFACE object representing this surface should
; have Restore called on it.
DDERR_SURFACELOST						EQU MAKE_DDHRESULT( 450 )

; The requested surface is not attached.
DDERR_SURFACENOTATTACHED				EQU MAKE_DDHRESULT( 460 )

; Height requested by DirectDraw is too large.
DDERR_TOOBIGHEIGHT						EQU MAKE_DDHRESULT( 470 )

; Size requested by DirectDraw is too large --	The individual height and
; width are OK.
DDERR_TOOBIGSIZE						EQU MAKE_DDHRESULT( 480 )

; Width requested by DirectDraw is too large.
DDERR_TOOBIGWIDTH						EQU MAKE_DDHRESULT( 490 )

; Action not supported.
DDERR_UNSUPPORTED						EQU E_NOTIMPh

; Pixel format requested is unsupported by DirectDraw
DDERR_UNSUPPORTEDFORMAT					EQU MAKE_DDHRESULT( 510 )

; Bitmask in the pixel format requested is unsupported by DirectDraw
DDERR_UNSUPPORTEDMASK					EQU MAKE_DDHRESULT( 520 )

; The specified stream contains invalid data
DDERR_INVALIDSTREAM						EQU MAKE_DDHRESULT( 521 )

; vertical blank is in progress
DDERR_VERTICALBLANKINPROGRESS			EQU MAKE_DDHRESULT( 537 )

; Informs DirectDraw that the previous Blt which is transfering information
; to or from this Surface is incomplete.
DDERR_WASSTILLDRAWING					EQU MAKE_DDHRESULT( 540 )

; The specified surface type requires specification of the COMPLEX flag
DDERR_DDSCAPSCOMPLEXREQUIRED			EQU MAKE_DDHRESULT( 542 )

; Rectangle provided was not horizontally aligned on reqd. boundary
DDERR_XALIGN							EQU MAKE_DDHRESULT( 560 )

; The GUID passed to DirectDrawCreate is not a valid DirectDraw driver
; identifier.
DDERR_INVALIDDIRECTDRAWGUID				EQU MAKE_DDHRESULT( 561 )

; A DirectDraw object representing this driver has already been created
; for this process.
DDERR_DIRECTDRAWALREADYCREATED			EQU MAKE_DDHRESULT( 562 )

; A hardware only DirectDraw object creation was attempted but the driver
; did not support any hardware.
DDERR_NODIRECTDRAWHW					EQU MAKE_DDHRESULT( 563 )

; this process already has created a primary surface
DDERR_PRIMARYSURFACEALREADYEXISTS		EQU MAKE_DDHRESULT( 564 )

; software emulation not available.
DDERR_NOEMULATION						EQU MAKE_DDHRESULT( 565 )

; region passed to Clipper::GetClipList is too small.
DDERR_REGIONTOOSMALL					EQU MAKE_DDHRESULT( 566 )

; an attempt was made to set a clip list for a clipper objec that
; is already monitoring an hwnd.
DDERR_CLIPPERISUSINGHWND				EQU MAKE_DDHRESULT( 567 )

; No clipper object attached to surface object
DDERR_NOCLIPPERATTACHED					EQU MAKE_DDHRESULT( 568 )

; Clipper notification requires an HWND or
; no HWND has previously been set as the CooperativeLevel HWND.
DDERR_NOHWND							EQU MAKE_DDHRESULT( 569 )

; HWND used by DirectDraw CooperativeLevel has been subclassed,
; this prevents DirectDraw from restoring state.
DDERR_HWNDSUBCLASSED					EQU MAKE_DDHRESULT( 570 )

; The CooperativeLevel HWND has already been set.
; It can not be reset while the process has surfaces or palettes created.
DDERR_HWNDALREADYSET					EQU MAKE_DDHRESULT( 571 )

; No palette object attached to this surface.
DDERR_NOPALETTEATTACHED					EQU MAKE_DDHRESULT( 572 )

; No hardware support for 16 or 256 color palettes.
DDERR_NOPALETTEHW						EQU MAKE_DDHRESULT( 573 )

; If a clipper object is attached to the source surface passed into a
; BltFast call.
DDERR_BLTFASTCANTCLIP					EQU MAKE_DDHRESULT( 574 )

; No blter.
DDERR_NOBLTHW							EQU MAKE_DDHRESULT( 575 )

; No DirectDraw ROP hardware.
DDERR_NODDROPSHW						EQU MAKE_DDHRESULT( 576 )

; returned when GetOverlayPosition is called on a hidden overlay
DDERR_OVERLAYNOTVISIBLE					EQU MAKE_DDHRESULT( 577 )

; returned when GetOverlayPosition is called on a overlay that UpdateOverlay
; has never been called on to establish a destionation.
DDERR_NOOVERLAYDEST						EQU MAKE_DDHRESULT( 578 )

; returned when the position of the overlay on the destionation is no longer
; legal for that destionation.
DDERR_INVALIDPOSITION					EQU MAKE_DDHRESULT( 579 )

; returned when an overlay member is called for a non-overlay surface
DDERR_NOTAOVERLAYSURFACE				EQU MAKE_DDHRESULT( 580 )

; An attempt was made to set the cooperative level when it was already
; set to exclusive.
DDERR_EXCLUSIVEMODEALREADYSET			EQU MAKE_DDHRESULT( 581 )

; An attempt has been made to flip a surface that is not flippable.
DDERR_NOTFLIPPABLE						EQU MAKE_DDHRESULT( 582 )

; Can't duplicate primary & 3D surfaces, or surfaces that are implicitly
; created.
DDERR_CANTDUPLICATE						EQU MAKE_DDHRESULT( 583 )

; Surface was not locked.  An attempt to unlock a surface that was not
; locked at all, or by this process, has been attempted.
DDERR_NOTLOCKED							EQU MAKE_DDHRESULT( 584 )

; Windows can not create any more DCs, or a DC was requested for a paltte-indexed
; surface when the surface had no palette AND the display mode was not palette-indexed
; (in this case DirectDraw cannot select a proper palette into the DC)
DDERR_CANTCREATEDC						EQU MAKE_DDHRESULT( 585 )

; No DC was ever created for this surface.
DDERR_NODC								EQU MAKE_DDHRESULT( 586 )

; This surface can not be restored because it was created in a different
; mode.
DDERR_WRONGMODE							EQU MAKE_DDHRESULT( 587 )

; This surface can not be restored because it is an implicitly created
; surface.
DDERR_IMPLICITLYCREATED					EQU MAKE_DDHRESULT( 588 )

; The surface being used is not a palette-based surface
DDERR_NOTPALETTIZED						EQU MAKE_DDHRESULT( 589 )

; The display is currently in an unsupported mode
DDERR_UNSUPPORTEDMODE					EQU MAKE_DDHRESULT( 590 )

; Operation could not be carried out because there is no mip-map
; texture mapping hardware present or available.
DDERR_NOMIPMAPHW						EQU MAKE_DDHRESULT( 591 )

; The requested action could not be performed because the surface was of
; the wrong type.
DDERR_INVALIDSURFACETYPE				EQU MAKE_DDHRESULT( 592 )

; Device does not support optimized surfaces, therefore no video memory optimized surfaces
DDERR_NOOPTIMIZEHW						EQU MAKE_DDHRESULT( 600 )

; Surface is an optimized surface, but has not yet been allocated any memory
DDERR_NOTLOADED							EQU MAKE_DDHRESULT( 601 )

; Attempt was made to create or set a device window without first setting
; the focus window
DDERR_NOFOCUSWINDOW						EQU MAKE_DDHRESULT( 602 )

; Attempt was made to set a palette on a mipmap sublevel
DDERR_NOTONMIPMAPSUBLEVEL				EQU MAKE_DDHRESULT( 603 )

; A DC has already been returned for this surface. Only one DC can be
; retrieved per surface.
DDERR_DCALREADYCREATED					EQU MAKE_DDHRESULT( 620 )

; An attempt was made to allocate non-local video memory from a device
; that does not support non-local video memory.
DDERR_NONONLOCALVIDMEM					EQU MAKE_DDHRESULT( 630 )

; The attempt to page lock a surface failed.
DDERR_CANTPAGELOCK						EQU MAKE_DDHRESULT( 640 )

; The attempt to page unlock a surface failed.
DDERR_CANTPAGEUNLOCK					EQU MAKE_DDHRESULT( 660 )

; An attempt was made to page unlock a surface with no outstanding page locks.
DDERR_NOTPAGELOCKED						EQU MAKE_DDHRESULT( 680 )

; There is more data available than the specified buffer size could hold
DDERR_MOREDATA							EQU MAKE_DDHRESULT( 690 )

; The data has expired and is therefore no longer valid.
DDERR_EXPIRED							EQU MAKE_DDHRESULT( 691 )

; The mode test has finished executing.
DDERR_TESTFINISHED						EQU MAKE_DDHRESULT( 692 )

; The mode test has switched to a new mode.
DDERR_NEWMODE							EQU MAKE_DDHRESULT( 693 )

; D3D has not yet been initialized.
DDERR_D3DNOTINITIALIZED					EQU MAKE_DDHRESULT( 694 )

; The video port is not active
DDERR_VIDEONOTACTIVE					EQU MAKE_DDHRESULT( 695 )

; The monitor does not have EDID data.
DDERR_NOMONITORINFORMATION				EQU MAKE_DDHRESULT( 696 )

; The driver does not enumerate display mode refresh rates.
DDERR_NODRIVERSUPPORT					EQU MAKE_DDHRESULT( 697 )

; Surfaces created by one direct draw device cannot be used directly by
; another direct draw device.
DDERR_DEVICEDOESNTOWNSURFACE			EQU MAKE_DDHRESULT( 699 )

; An attempt was made to invoke an interface member of a DirectDraw object
; created by CoCreateInstance() before it was initialized.
DDERR_NOTINITIALIZED					EQU CO_E_NOTINITIALIZED

ENDIF ; __DDRAW_INCLUDED__
